=== added file 'COPYING.BSD'
--- COPYING.BSD	1970-01-01 00:00:00 +0000
+++ COPYING.BSD	2010-09-28 07:45:44 +0000
@@ -0,0 +1,29 @@
+All rights reserved.
+
+Redistribution and use in source and binary forms, with or without
+modification, are permitted provided that the following conditions are
+met:
+
+    * Redistributions of source code must retain the above copyright
+notice, this list of conditions and the following disclaimer.
+
+    * Redistributions in binary form must reproduce the above
+copyright notice, this list of conditions and the following disclaimer
+in the documentation and/or other materials provided with the
+distribution.
+
+    * The names of its contributors may not be used to endorse or
+promote products derived from this software without specific prior
+written permission.
+
+THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

=== modified file 'Makefile.am'
--- Makefile.am	2010-09-21 22:26:25 +0000
+++ Makefile.am	2010-09-29 04:25:06 +0000
@@ -27,6 +27,8 @@
 lib_LTLIBRARIES = 
 noinst_LTLIBRARIES =
 noinst_PROGRAMS =
+man_MANS =
+bin_PROGRAMS =
 
 VERSION=$(PANDORA_RELEASE_VERSION)
 
@@ -40,6 +42,7 @@
 BUILT_SOURCES=
 EXTRA_DIST= \
 	    .quickly \
+	    COPYING.BSD \
 	    DRIZZLE.FAQ \
 	    EXCEPTIONS-CLIENT \
 	    config/autorun.sh \
@@ -133,7 +136,7 @@
 
 clean-local:
 	find . -name '*.gcno' | xargs rm -f 
-	-rm -rf docs/api docs/dev docs/_build
+	-rm -rf docs/api docs/dev docs/_build docs/doctrees
 
 include config/lint-source.am
 

=== modified file 'client/drizzle.cc'
--- client/drizzle.cc	2010-09-26 08:33:47 +0000
+++ client/drizzle.cc	2010-09-28 21:15:33 +0000
@@ -1295,12 +1295,9 @@
   N_("Continue even if we get an sql error."))
   ("named-commands,G", po::value<bool>(&named_cmds)->default_value(false)->zero_tokens(),
   N_("Enable named commands. Named commands mean this program's internal commands; see drizzle> help . When enabled, the named commands can be used from any line of the query, otherwise only from the first line, before an enter."))
-  ("ignore-spaces,i", N_("Ignore space after function names."))
   ("no-beep,b", po::value<bool>(&opt_nobeep)->default_value(false)->zero_tokens(),
   N_("Turn off beep on error."))
   ("disable-line-numbers", N_("Do not write line numbers for errors."))
-  ("skip-line-numbers,L", 
-  N_("Don't write line number for errors. WARNING: -L is deprecated, use long version of this option instead."))
   ("disable-column-names", N_("Do not write column names in results."))
   ("skip-column-names,N", 
   N_("Don't write column names in results. WARNING: -N is deprecated, use long version of this options instead."))
@@ -1367,7 +1364,6 @@
   N_("Append everything into outfile. See interactive help (\\h) also. Does not work in batch mode. Disable with --disable-tee. This option is disabled by default."))
   ("disable-tee", po::value<bool>()->default_value(false)->zero_tokens(), 
   N_("Disable outfile. See interactive help (\\h) also."))
-  ("wait,w", N_("Wait and retry if connection is down."))
   ("connect_timeout", po::value<uint32_t>(&opt_connect_timeout)->default_value(0)->notifier(&check_timeout_value),
   N_("Number of seconds before connection timeout."))
   ("max_input_line", po::value<uint32_t>(&opt_max_input_line)->default_value(16*1024L*1024L)->notifier(&check_max_input_line),

=== removed file 'client/drizzledump.1'
--- client/drizzledump.1	2010-03-22 14:33:29 +0000
+++ client/drizzledump.1	1970-01-01 00:00:00 +0000
@@ -1,1181 +0,0 @@
-.\"     Title: \fBdrizzledump\fR
-.\"    Author: 
-.\" Generator: DocBook XSL Stylesheets v1.70.1 <http://docbook.sf.net/>
-.\"      Date: 05/23/2009
-.\"    Manual: drizzle Database System
-.\"    Source: drizzle 6.0
-.\"
-.TH "\fBMYSQLDUMP\fR" "1" "05/23/2009" "drizzle" "drizzle Database System"
-.\" disable hyphenation
-.nh
-.\" disable justification (adjust text to left margin only)
-.ad l
-.SH "NAME"
-drizzledump \- a database backup program
-.SH "SYNOPSIS"
-.HP 45
-\fBdrizzledump [\fR\fB\fIoptions\fR\fR\fB] [\fR\fB\fIdb_name\fR\fR\fB [\fR\fB\fItbl_name\fR\fR\fB ...]]\fR
-.SH "DESCRIPTION"
-.PP
-The
-\fBdrizzledump\fR
-client is a backup program originally written by Igor Romanenko. It can be used to dump a database or a collection of databases for backup or transfer to another SQL server (not necessarily a drizzle server). The dump typically contains SQL statements to create the table, populate it, or both. However,
-\fBdrizzledump\fR
-can also be used to generate files in CSV, other delimited text, or XML format.
-.PP
-There are three general ways to invoke
-\fBdrizzledump\fR:
-.sp
-.RS 3n
-.nf
-shell> \fBdrizzledump [\fR\fB\fIoptions\fR\fR\fB] \fR\fB\fIdb_name\fR\fR\fB [\fR\fB\fItables\fR\fR\fB]\fR
-shell> \fBdrizzledump [\fR\fB\fIoptions\fR\fR\fB] \-\-databases \fR\fB\fIdb_name1\fR\fR\fB [\fR\fB\fIdb_name2\fR\fR\fB \fR\fB\fIdb_name3\fR\fR\fB...]\fR
-shell> \fBdrizzledump [\fR\fB\fIoptions\fR\fR\fB] \-\-all\-databases\fR
-.fi
-.RE
-.PP
-If you do not name any tables following
-\fIdb_name\fR
-or if you use the
-\fB\-\-databases\fR
-or
-\fB\-\-all\-databases\fR
-option, entire databases are dumped.
-.PP
-\fBdrizzledump\fR
-does not dump the
-INFORMATION_SCHEMA
-database. If you name that database explicitly on the command line,
-\fBdrizzledump\fR
-silently ignores it.
-.PP
-To get a list of the options your version of
-\fBdrizzledump\fR
-supports, execute
-\fBdrizzledump \-\-help\fR.
-.PP
-Some
-\fBdrizzledump\fR
-options are shorthand for groups of other options.
-\fB\-\-opt\fR
-and
-\fB\-\-compact\fR
-fall into this category. For example, use of
-\fB\-\-opt\fR
-is the same as specifying
-\fB\-\-add\-drop\-table\fR
-\fB\-\-add\-locks\fR
-\fB\-\-create\-options\fR
-\fB\-\-disable\-keys\fR
-\fB\-\-extended\-insert\fR
-\fB\-\-lock\-tables\fR
-\fB\-\-quick\fR
-\fB\-\-set\-charset\fR. Note that all of the options that
-\fB\-\-opt\fR
-stands for also are on by default because
-\fB\-\-opt\fR
-is on by default.
-.PP
-To reverse the effect of a group option, uses its
-\fB\-\-skip\-\fR\fB\fIxxx\fR\fR
-form (\fB\-\-skip\-opt\fR
-or
-\fB\-\-skip\-compact\fR). It is also possible to select only part of the effect of a group option by following it with options that enable or disable specific features. Here are some examples:
-.TP 3n
-\(bu
-To select the effect of
-\fB\-\-opt\fR
-except for some features, use the
-\fB\-\-skip\fR
-option for each feature. For example, to disable extended inserts and memory buffering, use
-\fB\-\-opt\fR
-\fB\-\-skip\-extended\-insert\fR
-\fB\-\-skip\-quick\fR. (
-\fB\-\-skip\-extended\-insert\fR
-\fB\-\-skip\-quick\fR
-is sufficient because
-\fB\-\-opt\fR
-is on by default.)
-.TP 3n
-\(bu
-To reverse
-\fB\-\-opt\fR
-for all features except index disabling and table locking, use
-\fB\-\-skip\-opt\fR
-\fB\-\-disable\-keys\fR
-\fB\-\-lock\-tables\fR.
-.sp
-.RE
-.PP
-When you selectively enable or disable the effect of a group option, order is important because options are processed first to last. For example,
-\fB\-\-disable\-keys\fR
-\fB\-\-lock\-tables\fR
-\fB\-\-skip\-opt\fR
-would not have the intended effect; it is the same as
-\fB\-\-skip\-opt\fR
-by itself.
-.PP
-\fBdrizzledump\fR
-can retrieve and dump table contents row by row, or it can retrieve the entire content from a table and buffer it in memory before dumping it. Buffering in memory can be a problem if you are dumping large tables. To dump tables row by row, use the
-\fB\-\-quick\fR
-option (or
-\fB\-\-opt\fR, which enables
-\fB\-\-quick\fR). The
-\fB\-\-opt\fR
-option (and hence
-\fB\-\-quick\fR) is enabled by default; to enable memory buffering, use
-\fB\-\-skip\-quick\fR.
-.PP
-If you are using a recent version of
-\fBdrizzledump\fR
-to generate a dump to be reloaded into a very old drizzle server, you should not use the
-\fB\-\-opt\fR
-or
-\fB\-\-extended\-insert\fR
-option. Use
-\fB\-\-skip\-opt\fR
-instead.
-.PP
-\fBdrizzledump\fR
-supports the options in the following list.
-.TP 3n
-\(bu
-\fB\-\-help\fR,
-\fB\-?\fR
-.sp
-Display a help message and exit.
-.TP 3n
-\(bu
-\fB\-\-add\-drop\-database\fR
-.sp
-Add a
-DROP DATABASE
-statement before each
-CREATE DATABASE
-statement.
-.TP 3n
-\(bu
-\fB\-\-add\-drop\-table\fR
-.sp
-Add a
-DROP TABLE
-statement before each
-CREATE TABLE
-statement.
-.TP 3n
-\(bu
-\fB\-\-add\-locks\fR
-.sp
-Surround each table dump with
-LOCK TABLES
-and
-UNLOCK TABLES
-statements. This results in faster inserts when the dump file is reloaded.
-.TP 3n
-\(bu
-\fB\-\-all\-databases\fR,
-\fB\-A\fR
-.sp
-Dump all tables in all databases. This is the same as using the
-\fB\-\-databases\fR
-option and naming all the databases on the command line.
-.TP 3n
-\(bu
-\fB\-\-allow\-keywords\fR
-.sp
-Allow creation of column names that are keywords. This works by prefixing each column name with the table name.
-.TP 3n
-\(bu
-\fB\-\-apply\-slave\-statements\fR
-.sp
-For a slave dump produced with the
-\fB\-\-dump\-slave\fR
-option, add a
-STOP SLAVE
-statement before the
-CHANGE MASTER TO
-statement and a
-START SLAVE
-statement at the end of the output.
-.TP 3n
-\(bu
-\fB\-\-character\-sets\-dir=\fR\fB\fIpath\fR\fR
-.sp
-The directory where character sets are installed.
-.TP 3n
-\(bu
-\fB\-\-comments\fR,
-\fB\-i\fR
-.sp
-Write additional information in the dump file such as program version, server version, and host. This option is enabled by default. To suppress this additional information, use
-\fB\-\-skip\-comments\fR.
-.TP 3n
-\(bu
-\fB\-\-compact\fR
-.sp
-Produce less verbose output. This option enables the
-\fB\-\-skip\-add\-drop\-table\fR,
-\fB\-\-skip\-add\-locks\fR,
-\fB\-\-skip\-comments\fR,
-\fB\-\-skip\-disable\-keys\fR, and
-\fB\-\-skip\-set\-charset\fR
-options.
-.TP 3n
-\(bu
-\fB\-\-compatible=\fR\fB\fIname\fR\fR
-.sp
-Produce output that is more compatible with other database systems or with older drizzle servers. The value of
-name
-can be
-ansi,
-mysql323,
-mysql40,
-postgresql,
-oracle,
-mssql,
-db2,
-maxdb,
-no_key_options,
-no_table_options, or
-no_field_options. To use several values, separate them by commas. These values have the same meaning as the corresponding options for setting the server SQL mode.
-.sp
-This option does not guarantee compatibility with other servers. It only enables those SQL mode values that are currently available for making dump output more compatible. For example,
-\fB\-\-compatible=oracle\fR
-does not map data types to Oracle types or use Oracle comment syntax.
-.sp
-\fIThis option requires a server version of 4.1.0 or higher\fR. With older servers, it does nothing.
-.TP 3n
-\(bu
-\fB\-\-complete\-insert\fR,
-\fB\-c\fR
-.sp
-Use complete
-INSERT
-statements that include column names.
-.TP 3n
-\(bu
-\fB\-\-compress\fR,
-\fB\-C\fR
-.sp
-Compress all information sent between the client and the server if both support compression.
-.TP 3n
-\(bu
-\fB\-\-create\-options\fR
-.sp
-Include all drizzle\-specific table options in the
-CREATE TABLE
-statements.
-.TP 3n
-\(bu
-\fB\-\-databases\fR,
-\fB\-B\fR
-.sp
-Dump several databases. Normally,
-\fBdrizzledump\fR
-treats the first name argument on the command line as a database name and following names as table names. With this option, it treats all name arguments as database names.
-CREATE DATABASE
-and
-USE
-statements are included in the output before each new database.
-.TP 3n
-\(bu
-\fB\-\-debug[=\fR\fB\fIdebug_options\fR\fR\fB]\fR,
-\fB\-# [\fR\fB\fIdebug_options\fR\fR\fB]\fR
-.sp
-Write a debugging log. A typical
-\fIdebug_options\fR
-string is
-\'d:t:o,\fIfile_name\fR'. The default value is
-\'d:t:o,/tmp/drizzledump.trace'.
-.TP 3n
-\(bu
-\fB\-\-debug\-check\fR
-.sp
-Print some debugging information when the program exits.
-.TP 3n
-\(bu
-\fB\-\-debug\-info\fR
-.sp
-Print debugging information and memory and CPU usage statistics when the program exits.
-.TP 3n
-\(bu
-\fB\-\-default\-character\-set=\fR\fB\fIcharset_name\fR\fR
-.sp
-Use
-\fIcharset_name\fR
-as the default character set. If no character set is specified,
-\fBdrizzledump\fR
-uses
-utf8
-.sp
-This option has no effect for output data files produced by using the
-\fB\-\-tab\fR
-option. See the description for that option.
-.TP 3n
-\(bu
-\fB\-\-delayed\-insert\fR
-.sp
-Write
-INSERT DELAYED
-statements rather than
-INSERT
-statements.
-.TP 3n
-\(bu
-\fB\-\-delete\-master\-logs\fR
-.sp
-On a master replication server, delete the binary logs after performing the dump operation. This option automatically enables
-\fB\-\-master\-data\fR.
-.TP 3n
-\(bu
-\fB\-\-disable\-keys\fR,
-\fB\-K\fR
-.sp
-For each table, surround the
-INSERT
-statements with
-/*!40000 ALTER TABLE \fItbl_name\fR DISABLE KEYS */;
-and
-/*!40000 ALTER TABLE \fItbl_name\fR ENABLE KEYS */;
-statements. This makes loading the dump file faster because the indexes are created after all rows are inserted. This option is effective only for non\-unique indexes of
-MyISAM
-tables.
-.TP 3n
-\(bu
-\fB\-\-dump\-date\fR
-.sp
-\fBdrizzledump\fR
-produces a
-\-\- Dump completed on \fIDATE\fR
-comment at the end of the dump if the
-\fB\-\-comments\fR
-option is given. However, the date causes dump files for identical data take at different times to appear to be different.
-\fB\-\-dump\-date\fR
-and
-\fB\-\-skip\-dump\-date\fR
-control whether the date is added to the comment. The default is
-\fB\-\-dump\-date\fR
-(include the date in the comment).
-\fB\-\-skip\-dump\-date\fR
-suppresses date printing.
-.TP 3n
-\(bu
-\fB\-\-dump\-slave[=\fR\fB\fIvalue\fR\fR\fB]\fR
-.sp
-This option is similar to
-\fB\-\-master\-data\fR
-except that it is used to dump a replication slave server to produce a dump file that can be used to set up another server as a slave that has the same master as the dumped server. It causes the dump output to include a
-CHANGE MASTER TO
-statement that indicates the binary log coordinates (file name and position) of the dumped slave's master (rather than the coordinates of the dumped server, as is done by the
-\fB\-\-master\-data\fR
-option). These are the master server coordinates from which the slave should start replicating.
-.sp
-The option value is handled the same way as for
-\fB\-\-master\-data\fR
-and has the same effect as
-\fB\-\-master\-data\fR
-in terms of enabling or disabling other options and in how locking is handled.
-.sp
-In conjunction with
-\fB\-\-dump\-slave\fR, the
-\fB\-\-apply\-slave\-statements\fR
-and
-\fB\-\-include\-master\-host\-port\fR
-options can also be used.
-.TP 3n
-\(bu
-\fB\-\-events\fR,
-\fB\-E\fR
-.sp
-Dump events from the dumped databases.
-.TP 3n
-\(bu
-\fB\-\-extended\-insert\fR,
-\fB\-e\fR
-.sp
-Use multiple\-row
-INSERT
-syntax that include several
-VALUES
-lists. This results in a smaller dump file and speeds up inserts when the file is reloaded.
-.TP 3n
-\(bu
-\fB\-\-fields\-terminated\-by=...\fR,
-\fB\-\-fields\-enclosed\-by=...\fR,
-\fB\-\-fields\-optionally\-enclosed\-by=...\fR,
-\fB\-\-fields\-escaped\-by=...\fR
-.sp
-These options are used with the
-\fB\-T\fR
-option and have the same meaning as the corresponding clauses for
-LOAD DATA INFILE. 
-.TP 3n
-\(bu
-\fB\-\-first\-slave\fR,
-\fB\-x\fR
-.sp
-Deprecated. Now renamed to
-\fB\-\-lock\-all\-tables\fR.
-.TP 3n
-\(bu
-\fB\-\-flush\-logs\fR,
-\fB\-F\fR
-.sp
-Flush the drizzle server log files before starting the dump. This option requires the
-RELOAD
-privilege. Note that if you use this option in combination with the
-\fB\-\-all\-databases\fR
-(or
-\fB\-A\fR) option, the logs are flushed
-\fIfor each database dumped\fR. The exception is when using
-\fB\-\-lock\-all\-tables\fR
-or
-\fB\-\-master\-data\fR: In this case, the logs are flushed only once, corresponding to the moment that all tables are locked. If you want your dump and the log flush to happen at exactly the same moment, you should use
-\fB\-\-flush\-logs\fR
-together with either
-\fB\-\-lock\-all\-tables\fR
-or
-\fB\-\-master\-data\fR.
-.TP 3n
-\(bu
-\fB\-\-flush\-privileges\fR
-.sp
-Emit a
-FLUSH PRIVILEGES
-statement after dumping the
-drizzle
-database. This option should be used any time the dump contains the
-drizzle
-database and any other database that depends on the data in the
-drizzle
-database for proper restoration.
-.TP 3n
-\(bu
-\fB\-\-force\fR,
-\fB\-f\fR
-.sp
-Continue even if an SQL error occurs during a table dump.
-.sp
-One use for this option is to cause
-\fBdrizzledump\fR
-to continue executing even when it encounters a view that has become invalid because the definition refers to a table that has been dropped. Without
-\fB\-\-force\fR,
-\fBdrizzledump\fR
-exits with an error message. With
-\fB\-\-force\fR,
-\fBdrizzledump\fR
-prints the error message, but it also writes an SQL comment containing the view definition to the dump output and continues executing.
-.TP 3n
-\(bu
-\fB\-\-host=\fR\fB\fIhost_name\fR\fR,
-\fB\-h \fR\fB\fIhost_name\fR\fR
-.sp
-Dump data from the drizzle server on the given host. The default host is
-localhost.
-.TP 3n
-\(bu
-\fB\-\-hex\-blob\fR
-.sp
-Dump binary columns using hexadecimal notation (for example,
-\'abc'
-becomes
-0x616263). The affected data types are
-BINARY,
-VARBINARY,
-BLOB, and
-BIT.
-.TP 3n
-\(bu
-\fB\-\-include\-master\-host\-port\fR
-.sp
-For the
-CHANGE MASTER TO
-statement in a slave dump produced with the
-\fB\-\-dump\-slave\fR
-option, add
-MASTER_PORT
-and
-MASTER_PORT
-options for the host name and TCP/IP port number of the slave's master.
-.TP 3n
-\(bu
-\fB\-\-ignore\-table=\fR\fB\fIdb_name.tbl_name\fR\fR
-.sp
-Do not dump the given table, which must be specified using both the database and table names. To ignore multiple tables, use this option multiple times. This option also can be used to ignore views.
-.TP 3n
-\(bu
-\fB\-\-insert\-ignore\fR
-.sp
-Write
-INSERT
-statements with the
-IGNORE
-option.
-.TP 3n
-\(bu
-\fB\-\-lines\-terminated\-by=...\fR
-.sp
-This option is used with the
-\fB\-T\fR
-option and has the same meaning as the corresponding clause for
-LOAD DATA INFILE. 
-.TP 3n
-\(bu
-\fB\-\-lock\-all\-tables\fR,
-\fB\-x\fR
-.sp
-Lock all tables across all databases. This is achieved by acquiring a global read lock for the duration of the whole dump. This option automatically turns off
-\fB\-\-single\-transaction\fR
-and
-\fB\-\-lock\-tables\fR.
-.TP 3n
-\(bu
-\fB\-\-lock\-tables\fR,
-\fB\-l\fR
-.sp
-Lock all tables before dumping them. The tables are locked with
-READ LOCAL
-to allow concurrent inserts in the case of
-MyISAM
-tables. For transactional tables such as
-InnoDB
-and
-BDB,
-\fB\-\-single\-transaction\fR
-is a much better option, because it does not need to lock the tables at all.
-.sp
-Please note that when dumping multiple databases,
-\fB\-\-lock\-tables\fR
-locks tables for each database separately. Therefore, this option does not guarantee that the tables in the dump file are logically consistent between databases. Tables in different databases may be dumped in completely different states.
-.TP 3n
-\(bu
-\fB\-\-log\-error=\fR\fB\fIfile_name\fR\fR
-.sp
-Append warnings and errors to the named file.
-.TP 3n
-\(bu
-\fB\-\-master\-data[=\fR\fB\fIvalue\fR\fR\fB]\fR
-.sp
-Use this option to dump a master replication server to produce a dump file that can be used to set up another server as a slave of the master. It causes the dump output to include a
-CHANGE MASTER TO
-statement that indicates the binary log coordinates (file name and position) of the dumped server. These are the master server coordinates from which the slave should start replicating.
-.sp
-If the option value is 2, the
-CHANGE MASTER TO
-statement is written as an SQL comment, and thus is informative only; it has no effect when the dump file is reloaded. If the option value is 1, the statement takes effect when the dump file is reloaded. If the option value is not specified, the default value is 1.
-.sp
-This option requires the
-RELOAD
-privilege and the binary log must be enabled.
-.sp
-The
-\fB\-\-master\-data\fR
-option automatically turns off
-\fB\-\-lock\-tables\fR. It also turns on
-\fB\-\-lock\-all\-tables\fR, unless
-\fB\-\-single\-transaction\fR
-also is specified, in which case, a global read lock is acquired only for a short time at the beginning of the dump (see the description for
-\fB\-\-single\-transaction\fR). In all cases, any action on logs happens at the exact moment of the dump.
-.sp
-It is also possible to set up a slave by dumping an existing slave of the master. To do this, use the
-\fB\-\-dump\-slave\fR
-option instead.
-.TP 3n
-\(bu
-\fB\-\-no\-autocommit\fR
-.sp
-Enclose the
-INSERT
-statements for each dumped table within
-SET autocommit = 0
-and
-COMMIT
-statements.
-.TP 3n
-\(bu
-\fB\-\-no\-create\-db\fR,
-\fB\-n\fR
-.sp
-This option suppresses the
-CREATE DATABASE
-statements that are otherwise included in the output if the
-\fB\-\-databases\fR
-or
-\fB\-\-all\-databases\fR
-option is given.
-.TP 3n
-\(bu
-\fB\-\-no\-create\-info\fR,
-\fB\-t\fR
-.sp
-Do not write
-CREATE TABLE
-statements that re\-create each dumped table.
-.TP 3n
-\(bu
-\fB\-\-no\-data\fR,
-\fB\-d\fR
-.sp
-Do not write any table row information (that is, do not dump table contents). This is very useful if you want to dump only the
-CREATE TABLE
-statement for the table.
-.TP 3n
-\(bu
-\fB\-\-no\-set\-names\fR
-.sp
-This option is deprecated. Use
-\fB\-\-skip\-set\-charset\fR. instead.
-.TP 3n
-\(bu
-\fB\-\-opt\fR
-.sp
-This option is shorthand; it is the same as specifying
-\fB\-\-add\-drop\-table\fR
-\fB\-\-add\-locks\fR
-\fB\-\-create\-options\fR
-\fB\-\-disable\-keys\fR
-\fB\-\-extended\-insert\fR
-\fB\-\-lock\-tables\fR
-\fB\-\-quick\fR
-\fB\-\-set\-charset\fR. It should give you a fast dump operation and produce a dump file that can be reloaded into a drizzle server quickly.
-.sp
-\fIThe \fR\fI\fB\-\-opt\fR\fR\fI option is enabled by default. Use \fR\fI\fB\-\-skip\-opt\fR\fR\fI to disable it.\fR
-See the discussion at the beginning of this section for information about selectively enabling or disabling certain of the options affected by
-\fB\-\-opt\fR.
-.TP 3n
-\(bu
-\fB\-\-order\-by\-primary\fR
-.sp
-Sorts each table's rows by its primary key, or by its first unique index, if such an index exists. This is useful when dumping a
-MyISAM
-table to be loaded into an
-InnoDB
-table, but will make the dump itself take considerably longer.
-.TP 3n
-\(bu
-\fB\-\-password[=\fR\fB\fIpassword\fR\fR\fB]\fR,
-\fB\-p[\fR\fB\fIpassword\fR\fR\fB]\fR
-.sp
-The password to use when connecting to the server. If you use the short option form (\fB\-p\fR), you
-\fIcannot\fR
-have a space between the option and the password. If you omit the
-\fIpassword\fR
-value following the
-\fB\-\-password\fR
-or
-\fB\-p\fR
-option on the command line, you are prompted for one.
-.sp
-Specifying a password on the command line should be considered insecure. 
-.TP 3n
-\(bu
-\fB\-\-pipe\fR,
-\fB\-W\fR
-.sp
-On Windows, connect to the server via a named pipe. This option applies only for connections to a local server, and only if the server supports named\-pipe connections.
-.TP 3n
-\(bu
-\fB\-\-port=\fR\fB\fIport_num\fR\fR,
-\fB\-P \fR\fB\fIport_num\fR\fR
-.sp
-The TCP/IP port number to use for the connection.
-.TP 3n
-\(bu
-\fB\-\-protocol={TCP|SOCKET|PIPE|MEMORY}\fR
-.sp
-The connection protocol to use for connecting to the server. It is useful when the other connection parameters normally would cause a protocol to be used other than the one you want.
-.TP 3n
-\(bu
-\fB\-\-quick\fR,
-\fB\-q\fR
-.sp
-This option is useful for dumping large tables. It forces
-\fBdrizzledump\fR
-to retrieve rows for a table from the server a row at a time rather than retrieving the entire row set and buffering it in memory before writing it out.
-.TP 3n
-\(bu
-\fB\-\-quote\-names\fR,
-\fB\-Q\fR
-.sp
-Quote database, table, and column names within
-\(lq`\(rq
-characters. If the
-ANSI_QUOTES
-SQL mode is enabled, names are quoted within
-\(lq"\(rq
-characters. This option is enabled by default. It can be disabled with
-\fB\-\-skip\-quote\-names\fR, but this option should be given after any option such as
-\fB\-\-compatible\fR
-that may enable
-\fB\-\-quote\-names\fR.
-.TP 3n
-\(bu
-\fB\-\-replace\fR
-.sp
-Write
-REPLACE
-statements rather than
-INSERT
-statements.
-.TP 3n
-\(bu
-\fB\-\-result\-file=\fR\fB\fIfile_name\fR\fR,
-\fB\-r \fR\fB\fIfile_name\fR\fR
-.sp
-Direct output to a given file. This option should be used on Windows to prevent newline
-\(lq\\n\(rq
-characters from being converted to
-\(lq\\r\\n\(rq
-carriage return/newline sequences. The result file is created and its contents overwritten, even if an error occurs while generating the dump. The previous contents are lost.
-.TP 3n
-\(bu
-\fB\-\-routines\fR,
-\fB\-R\fR
-.sp
-Dump stored routines (procedures and functions) from the dumped databases. Use of this option requires the
-SELECT
-privilege for the
-drizzle.proc
-table. The output generated by using
-\fB\-\-routines\fR
-contains
-CREATE PROCEDURE
-and
-CREATE FUNCTION
-statements to re\-create the routines. However, these statements do not include attributes such as the routine creation and modification timestamps. This means that when the routines are reloaded, they will be created with the timestamps equal to the reload time.
-.sp
-If you require routines to be re\-created with their original timestamp attributes, do not use
-\fB\-\-routines\fR. Instead, dump and reload the contents of the
-drizzle.proc
-table directly, using a drizzle account that has appropriate privileges for the
-drizzle
-database.
-.TP 3n
-\(bu
-\fB\-\-set\-charset\fR
-.sp
-Add
-SET NAMES \fIdefault_character_set\fR
-to the output. This option is enabled by default. To suppress the
-SET NAMES
-statement, use
-\fB\-\-skip\-set\-charset\fR.
-.TP 3n
-\(bu
-\fB\-\-single\-transaction\fR
-.sp
-This option issues a
-BEGIN
-SQL statement before dumping data from the server. It is useful only with transactional tables such as
-InnoDB, because then it dumps the consistent state of the database at the time when
-BEGIN
-was issued without blocking any applications.
-.sp
-When using this option, you should keep in mind that only
-InnoDB
-and
-Falcon
-tables are dumped in a consistent state. For example, any
-MyISAM
-or
-MEMORY
-tables dumped while using this option may still change state.
-.sp
-While a
-\fB\-\-single\-transaction\fR
-dump is in process, to ensure a valid dump file (correct table contents and binary log position), no other connection should use the following statements:
-ALTER TABLE,
-DROP TABLE,
-RENAME TABLE,
-TRUNCATE TABLE. A consistent read is not isolated from those statements, so use of them on a table to be dumped can cause the
-SELECT
-performed by
-\fBdrizzledump\fR
-to retrieve the table contents to obtain incorrect contents or fail.
-.sp
-The
-\fB\-\-single\-transaction\fR
-option and the
-\fB\-\-lock\-tables\fR
-option are mutually exclusive, because
-LOCK TABLES
-causes any pending transactions to be committed implicitly.
-.sp
-To dump large tables, you should combine this option with
-\fB\-\-quick\fR.
-.TP 3n
-\(bu
-\fB\-\-skip\-comments\fR
-.sp
-See the description for the
-\fB\-\-comments\fR
-option.
-.TP 3n
-\(bu
-\fB\-\-skip\-opt\fR
-.sp
-See the description for the
-\fB\-\-opt\fR
-option.
-.TP 3n
-\(bu
-\fB\-\-socket=\fR\fB\fIpath\fR\fR,
-\fB\-S \fR\fB\fIpath\fR\fR
-.sp
-For connections to
-localhost, the Unix socket file to use, or, on Windows, the name of the named pipe to use.
-.TP 3n
-\(bu
-\fB\-\-ssl*\fR
-.sp
-Options that begin with
-\fB\-\-ssl\fR
-specify whether to connect to the server via SSL and indicate where to find SSL keys and certificates. 
-.TP 3n
-\(bu
-\fB\-\-tab=\fR\fB\fIpath\fR\fR,
-\fB\-T \fR\fB\fIpath\fR\fR
-.sp
-Produce tab\-separated data files. For each dumped table,
-\fBdrizzledump\fR
-creates a
-\fI\fItbl_name\fR\fR\fI.sql\fR
-file that contains the
-CREATE TABLE
-statement that creates the table, and a
-\fI\fItbl_name\fR\fR\fI.txt\fR
-file that contains its data. The option value is the directory in which to write the files.
-.sp
-By default, the
-\fI.txt\fR
-data files are formatted using tab characters between column values and a newline at the end of each line. The format can be specified explicitly using the
-\fB\-\-fields\-\fR\fB\fIxxx\fR\fR
-and
-\fB\-\-lines\-terminated\-by\fR
-options.
-.sp
-Column values are dumped using the
-binary
-character set and the
-\fB\-\-default\-character\-set\fR
-option is ignored. In effect, there is no character set conversion. If a table contains columns in several character sets, the output data file will as well and you may not be able to reload the file correctly.
-.sp
-.it 1 an-trap
-.nr an-no-space-flag 1
-.nr an-break-flag 1
-.br
-\fBNote\fR
-This option should be used only when
-\fBdrizzledump\fR
-is run on the same machine as the
-\fBdrizzled\fR
-server. You must have the
-FILE
-privilege, and the server must have permission to write files in the directory that you specify.
-.TP 3n
-\(bu
-\fB\-\-tables\fR
-.sp
-Override the
-\fB\-\-databases\fR
-or
-\fB\-B\fR
-option.
-\fBdrizzledump\fR
-regards all name arguments following the option as table names.
-.TP 3n
-\(bu
-\fB\-\-triggers\fR
-.sp
-Dump triggers for each dumped table. This option is enabled by default; disable it with
-\fB\-\-skip\-triggers\fR.
-.TP 3n
-\(bu
-\fB\-\-tz\-utc\fR
-.sp
-This option enables
-TIMESTAMP
-columns to be dumped and reloaded between servers in different time zones.
-\fBdrizzledump\fR
-sets its connection time zone to UTC and adds
-SET TIME_ZONE='+00:00'
-to the dump file. Without this option,
-TIMESTAMP
-columns are dumped and reloaded in the time zones local to the source and destination servers, which can cause the values to change.
-\fB\-\-tz\-utc\fR
-also protects against changes due to daylight saving time.
-\fB\-\-tz\-utc\fR
-is enabled by default. To disable it, use
-\fB\-\-skip\-tz\-utc\fR.
-.TP 3n
-\(bu
-\fB\-\-user=\fR\fB\fIuser_name\fR\fR,
-\fB\-u \fR\fB\fIuser_name\fR\fR
-.sp
-The drizzle user name to use when connecting to the server.
-.TP 3n
-\(bu
-\fB\-\-verbose\fR,
-\fB\-v\fR
-.sp
-Verbose mode. Print more information about what the program does.
-.TP 3n
-\(bu
-\fB\-\-version\fR,
-\fB\-V\fR
-.sp
-Display version information and exit.
-.TP 3n
-\(bu
-\fB\-\-where='\fR\fB\fIwhere_condition\fR\fR\fB'\fR,
-\fB\-w '\fR\fB\fIwhere_condition\fR\fR\fB'\fR
-.sp
-Dump only rows selected by the given
-WHERE
-condition. Quotes around the condition are mandatory if it contains spaces or other characters that are special to your command interpreter.
-.sp
-Examples:
-.sp
-.RS 3n
-.nf
-\-\-where="user='jimf'"
-\-w"userid>1"
-\-w"userid<1"
-.fi
-.RE
-.TP 3n
-\(bu
-\fB\-\-xml\fR,
-\fB\-X\fR
-.sp
-Write dump output as well\-formed XML.
-.sp
-\fBNULL\fR\fB, \fR\fB'NULL'\fR\fB, and Empty Values\fR: For some column named
-\fIcolumn_name\fR, the
-NULL
-value, an empty string, and the string value
-\'NULL'
-are distinguished from one another in the output generated by this option as follows.
-.TS
-allbox tab(:);
-l l
-l l
-l l
-l l.
-T{
-\fBValue\fR:
-T}:T{
-\fBXML Representation\fR:
-T}
-T{
-NULL (\fIunknown value\fR)
-T}:T{
-<field name="\fIcolumn_name\fR"
-       xsi:nil="true" />
-T}
-T{
-\'' (\fIempty string\fR)
-T}:T{
-<field name="\fIcolumn_name\fR">
-</field>
-T}
-T{
-\'NULL' (\fIstring value\fR)
-T}:T{
-<field name="\fIcolumn_name\fR">
-NULL
-</field>
-T}
-.TE
-.sp
-The output from the
-\fBdrizzle\fR
-client when run using the
-\fB\-\-xml\fR
-option also follows these rules. (See
-the section called \(lq\fBMYSQL\fR OPTIONS\(rq.)
-.sp
-XML output from
-\fBdrizzledump\fR
-includes the XML namespace, as shown here:
-.sp
-.RS 3n
-.nf
-shell> \fBdrizzledump \-\-xml \-u root world City\fR
-<?xml version="1.0"?>
-<drizzledump xmlns:xsi="http://www.w3.org/2001/XMLSchema\-instance">
-<database name="world">
-<table_structure name="City">
-<field Field="ID" Type="int(11)" Null="NO" Key="PRI" Extra="auto_increment" />
-<field Field="Name" Type="char(35)" Null="NO" Key="" Default="" Extra="" />
-<field Field="CountryCode" Type="char(3)" Null="NO" Key="" Default="" Extra="" />
-<field Field="District" Type="char(20)" Null="NO" Key="" Default="" Extra="" />
-<field Field="Population" Type="int(11)" Null="NO" Key="" Default="0" Extra="" />
-<key Table="City" Non_unique="0" Key_name="PRIMARY" Seq_in_index="1" Column_name="ID" Collation="A" Cardinality="4079"
-Null="" Index_type="BTREE" Comment="" />
-<options Name="City" Engine="MyISAM" Version="10" Row_format="Fixed" Rows="4079" Avg_row_length="67" Data_length="27329
-3" Max_data_length="18858823439613951" Index_length="43008" Data_free="0" Auto_increment="4080" Create_time="2007\-03\-31 01:47:01" Updat
-e_time="2007\-03\-31 01:47:02" Collation="latin1_swedish_ci" Create_options="" Comment="" />
-</table_structure>
-<table_data name="City">
-<row>
-<field name="ID">1</field>
-<field name="Name">Kabul</field>
-<field name="CountryCode">AFG</field>
-<field name="District">Kabol</field>
-<field name="Population">1780000</field>
-</row>
-\fI...\fR
-<row>
-<field name="ID">4079</field>
-<field name="Name">Rafah</field>
-<field name="CountryCode">PSE</field>
-<field name="District">Rafah</field>
-<field name="Population">92020</field>
-</row>
-</table_data>
-</database>
-</drizzledump>
-.fi
-.RE
-.sp
-.sp
-.RE
-.PP
-You can also set the following variables by using
-\fB\-\-\fR\fB\fIvar_name\fR\fR\fB=\fR\fB\fIvalue\fR\fR
-syntax:
-.TP 3n
-\(bu
-max_allowed_packet
-.sp
-The maximum size of the buffer for client/server communication. The maximum is 1GB.
-.TP 3n
-\(bu
-net_buffer_length
-.sp
-The initial size of the buffer for client/server communication. When creating multiple\-row\-insert statements (as with option
-\fB\-\-extended\-insert\fR
-or
-\fB\-\-opt\fR),
-\fBdrizzledump\fR
-creates rows up to
-net_buffer_length
-length. If you increase this variable, you should also ensure that the
-net_buffer_length
-variable in the drizzle server is at least this large.
-.sp
-.RE
-.PP
-The most common use of
-\fBdrizzledump\fR
-is probably for making a backup of an entire database:
-.sp
-.RS 3n
-.nf
-shell> \fBdrizzledump \fR\fB\fIdb_name\fR\fR\fB > \fR\fB\fIbackup\-file.sql\fR\fR
-.fi
-.RE
-.PP
-You can read the dump file back into the server like this:
-.sp
-.RS 3n
-.nf
-shell> \fBdrizzle \fR\fB\fIdb_name\fR\fR\fB < \fR\fB\fIbackup\-file.sql\fR\fR
-.fi
-.RE
-.PP
-Or like this:
-.sp
-.RS 3n
-.nf
-shell> \fBdrizzle \-e "source \fR\fB\fI/path\-to\-backup/backup\-file.sql\fR\fR\fB" \fR\fB\fIdb_name\fR\fR
-.fi
-.RE
-.PP
-\fBdrizzledump\fR
-is also very useful for populating databases by copying data from one drizzle server to another:
-.sp
-.RS 3n
-.nf
-shell> \fBdrizzledump \-\-opt \fR\fB\fIdb_name\fR\fR\fB | drizzle \-\-host=\fR\fB\fIremote_host\fR\fR\fB \-C \fR\fB\fIdb_name\fR\fR
-.fi
-.RE
-.PP
-It is possible to dump several databases with one command:
-.sp
-.RS 3n
-.nf
-shell> \fBdrizzledump \-\-databases \fR\fB\fIdb_name1\fR\fR\fB [\fR\fB\fIdb_name2\fR\fR\fB ...] > my_databases.sql\fR
-.fi
-.RE
-.PP
-To dump all databases, use the
-\fB\-\-all\-databases\fR
-option:
-.sp
-.RS 3n
-.nf
-shell> \fBdrizzledump \-\-all\-databases > all_databases.sql\fR
-.fi
-.RE
-.PP
-For
-InnoDB
-tables,
-\fBdrizzledump\fR
-provides a way of making an online backup:
-.sp
-.RS 3n
-.nf
-shell> \fBdrizzledump \-\-all\-databases \-\-single\-transaction > all_databases.sql\fR
-.fi
-.RE
-.PP
-This backup acquires a global read lock on all tables (using
-FLUSH TABLES WITH READ LOCK) at the beginning of the dump. As soon as this lock has been acquired, the binary log coordinates are read and the lock is released. If long updating statements are running when the
-FLUSH
-statement is issued, the drizzle server may get stalled until those statements finish. After that, the dump becomes lock\-free and does not disturb reads and writes on the tables. If the update statements that the drizzle server receives are short (in terms of execution time), the initial lock period should not be noticeable, even with many updates.
-.PP
-For point\-in\-time recovery (also known as
-\(lqroll\-forward,\(rq
-when you need to restore an old backup and replay the changes that happened since that backup), it is often useful to rotate the binary log , \(lqThe Binary Log\(rq) or at least know the binary log coordinates to which the dump corresponds:
-.sp
-.RS 3n
-.nf
-shell> \fBdrizzledump \-\-all\-databases \-\-master\-data=2 > all_databases.sql\fR
-.fi
-.RE
-.PP
-Or:
-.sp
-.RS 3n
-.nf
-shell> \fBdrizzledump \-\-all\-databases \-\-flush\-logs \-\-master\-data=2\fR
-              \fB> all_databases.sql\fR
-.fi
-.RE
-.PP
-The
-\fB\-\-master\-data\fR
-and
-\fB\-\-single\-transaction\fR
-options can be used simultaneously, which provides a convenient way to make an online backup suitable for point\-in\-time recovery if tables are stored using the
-InnoDB
-storage engine.
-.PP
-If you encounter problems backing up views, please read the section that covers restrictions on views which describes a workaround for backing up views when this fails due to insufficient privileges. 
-.SH "COPYRIGHT"
-.PP
-Copyright 2007\-2008 MySQL AB, 2009 Sun Microsystems, Inc.
-Copyright 2010 Drizzle Team
-.PP
-This documentation is free software; you can redistribute it and/or modify it only under the terms of the GNU General Public License as published by the Free Software Foundation; version 2 of the License.
-.PP
-This documentation is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
-.PP
-You should have received a copy of the GNU General Public License along with the program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110\-1301 USA or see http://www.gnu.org/licenses/.
-.SH "SEE ALSO"
-For more information, please refer to http://www.drizzle.org/wiki.
-.SH AUTHOR
-Sun Microsystems, Inc. (http://www.mysql.com/), Drizzle Team

=== modified file 'client/include.am'
--- client/include.am	2010-09-23 17:56:06 +0000
+++ client/include.am	2010-09-28 17:34:48 +0000
@@ -15,18 +15,17 @@
 noinst_PROGRAMS+= \
 		  client/drizzletest
 
-bin_PROGRAMS= \
-	      client/drizzle \
-	      client/drizzledump \
-	      client/drizzleimport \
-	      client/drizzleslap
+bin_PROGRAMS+= \
+	       client/drizzle \
+	       client/drizzledump \
+	       client/drizzleimport \
+	       client/drizzleslap
 
-man_MANS= \
-	  client/drizzle.1 \
-	  client/drizzled.8 \
-	  client/drizzledump.1 \
-	  client/drizzleimport.1 \
-	  client/drizzleslap.1
+man_MANS+= \
+	   client/drizzle.1 \
+	   client/drizzled.8 \
+	   client/drizzleimport.1 \
+	   client/drizzleslap.1
 
 client_libgetpassword_la_SOURCES= client/get_password.cc
 

=== modified file 'docs/clients/drizzledump.rst'
--- docs/clients/drizzledump.rst	2010-09-26 21:24:38 +0000
+++ docs/clients/drizzledump.rst	2010-09-28 17:34:48 +0000
@@ -1,6 +1,262 @@
 Drizzledump Backup Tool
 =======================
 
-The :program:`drizzledump` command line tool is used for backing up and
+Synopsis
+--------
+
+**drizzledump** [*OPTIONS*] *database* [*tables*]
+
+**drizzledump** [*OPTIONS*] *--databases* [*OPTIONS*] *DB1* [*DB2* *DB3*...]
+
+**drizzledump** [*OPTIONS*] *--all-databases* [*OPTIONS*]
+
+Description
+-----------
+
+:program:`drizzledump` is used for backing up and
 restoring logical backups of a Drizzle database, as well as for migrating
-from *MySQL*.
+from *MySQL*. 
+
+When connecting to a Drizzle server it will do a plain dump of the server.  It
+will, however, automatically detect when it is connected to a *MySQL* server and
+will convert the tables and data into a Drizzle compatible format.
+
+Any binary data in tables will be converted into hexadecimal output so that it
+does not corrupt the dump file.
+
+Drizzledump options
+-------------------
+
+The :program:`drizzledump` tool has several available options:
+
+.. option:: -A, --all-databases
+   
+   Dumps all databases found on the server apart from *information_schema* and
+   *data_dictionary* in Drizzle and *information_schema*, *performance_schema*
+   and *mysql* in MySQL.
+
+.. option:: -c, --complete-insert
+
+   Dumps using complete insert statements. *CURRENTLY BROKEN*
+
+.. option:: -C, --compress
+
+   Use client/server compression protocol.
+
+.. option:: -F, --flush-logs
+
+   Flush the server logs before commencing with the dump. *CURRENTLY_BROKEN*
+
+.. option:: -f, --force
+
+   Continue even if we get an sql-error. *CURRENTLY_BROKEN*
+
+.. option:: -?, --help
+
+   Show a message with all the available options.
+
+.. option:: -x, --lock-all-tables
+
+   Locks all the tables for all databases with a global read lock.  The lock is
+   released automatically when :program:`drizzledump` ends.
+   Turns on :option:`--single-transaction` and :option:`--lock-tables`.
+
+.. option:: --single-transaction
+
+   Creates a consistent snapshot by dumping the tables in a single transaction.
+   During the snapshot no other connected client should use any of the
+   following as this will implicitly commit the transaction and prevent the
+   consistency::
+
+      ALTER TABLE
+      DROP TABLE
+      RENAME TABLE
+      TRUNCATE TABLE
+
+   Only works with InnoDB.  Automatically disables :option:`--lock-tables`.
+
+.. option:: --disable-opt
+
+   A shortcut for :option:`--skip-drop-table`, :option:`--skip-locks`,
+   :option:`--skip-create`, :option:`--slow`, :option:`--skip-extended-insert`
+   and :option:`--skip-disable-keys`
+
+.. option:: --tables t1 t2 ...
+
+   Dump a list of tables.
+
+.. option:: --show-progress-size rows (=10000)
+
+   Show progress of the dump every *rows* of the dump.  Requires
+   :option:`--verbose`
+
+.. option:: -v, --verbose
+
+   Sends various verbose information to stderr as the dump progresses.
+
+.. option:: --skip-create
+
+   Do not dump the CREATE TABLE / CREATE DATABASE statements.
+
+.. option:: --skip-extended-insert
+
+   Dump every row on an individual line.  For example::
+
+     INSERT INTO `t1` VALUES (1,'hello');
+     INSERT INTO `t1` VALUES (2,'world');
+
+.. option:: --skip-dump-date
+
+   Do not display the date/time at the end of the dump.
+
+.. option:: --no-defaults
+
+   Do not attempt to read configuration from configuration files.
+
+.. option:: --add-drop-database
+
+   Add `DROP DATABASE` statements before `CREATE DATABASE`.
+
+.. option:: --compact
+
+   Gives a more compact output by disabling header/footer comments and enabling
+   :option:`--skip-add-drop-table`, :option:`--no-set-names`,
+   :option:`--skip-disable-keys` and :option:`--skip-add-locks`.
+
+.. option:: -B, --databases
+
+   Dump several databases.  The databases do not need to follow on after this
+   option, they can be anywhere in the command line.
+
+.. option:: --insert-ignore
+
+   Add the `IGNORE` keyword into every `INSERT` statement.
+
+.. option:: --no-autocommit
+
+   Make the dump of each table a single transaction by wrapping it in `COMMIT`
+   statements.
+
+.. option:: -n, --no-create-db
+
+   Do not output the `CREATE DATABASE` statements when using
+   :option:`--all-databases` or :option:`--databases`.
+
+.. option:: -d, --no-data
+
+   Do not dump the data itself, used to dump the schemas only.
+
+.. option:: --slow
+
+   Dump directly from database to destination rather than using a query buffer.
+
+.. option:: --replace
+
+   Use `REPLACE INTO` statements instead of `INSERT INTO`
+
+.. option:: --destination-type type (=stdout)
+
+   Destination of the data.
+
+   **stdout**
+      The default.  Output to the command line
+
+   **database**
+      Connect to another database and pipe data to that.
+
+   .. versionadded:: 2010-09-27
+
+.. option:: --destination-host hostname (=localhost)
+
+   The hostname for the destination database.  Requires
+   :option:`--destination-type` `= database`
+
+   .. versionadded:: 2010-09-27
+
+.. option:: --destination-port port (=3306)
+
+   The port number for the destination database.  Requires
+   :option:`--destination-type` `= database`
+
+  .. versionadded:: 2010-09-27
+
+.. option:: --destination-user username
+
+   The username for the destinations database.  Requires
+   :option:`--destination-type` `= database`
+
+  .. versionadded:: 2010-09-27
+
+.. option:: --destination-password password
+
+   The password for the destination database.  Requires
+   :option:`--destination-type` `= database`
+
+  .. versionadded:: 2010-09-27
+
+.. option:: --destination-database database
+
+   The database for the destination database, for use when only dumping a
+   single database.  Requires
+   :option:`--destination-type` `= database`
+
+  .. versionadded:: 2010-09-27
+
+.. option:: -h, --host hostname (=localhost)
+
+   The hostname of the database server.
+
+.. option:: -u, --user username
+
+   The username for the database server.
+
+.. option:: -P, --password password
+
+   The password for the database server.
+
+.. option:: -p, --port port (=3306,4427)
+
+   The port number of the database server.  Defaults to 3306 for MySQL protocol
+   and 4427 for Drizzle protocol.
+
+.. option:: --protocol protocol (=mysql)
+
+   The protocol to use when connecting to the database server.  Options are:
+
+   **mysql**
+      The standard MySQL protocol.
+
+   **drizzle**
+      The Drizzle protocol.
+
+Backups using Drizzledump
+-------------------------
+
+Backups of a database can be made very simply by running the following::
+
+     $ drizzledump --all-databases > dumpfile.sql
+
+This can then be re-imported into drizzle at a later date using::
+
+     $ drizzle < dumpfile.sql
+
+MySQL Migration using Drizzledump
+---------------------------------
+
+As of version 2010-09-27 there is the capability to migrate databases from
+MySQL to Drizzle using :program:`drizzledump`.
+
+:program:`drizzledump` will automatically detect whether it is talking to a
+MySQL or Drizzle database server.  If it is connected to a MySQL server it will
+automatically convert all the structures and data into a Drizzle compatible 
+format.
+
+So, simply connecting to a MySQL server with :program:`drizzledump` as follows
+will give you a Drizzle compatible output::
+
+     $ drizzledump --all-databases --host=mysql-host --user=mysql-user --password > dumpfile.sql
+
+Additionally :program:`drizzledump` can now dump from MySQL and import directly
+into a Drizzle server as follows::
+
+     $ drizzledump --all-databases --host=mysql-host --user=mysql-user --password --destination-type=database --desination-host=drizzle-host

=== modified file 'docs/conf.py'
--- docs/conf.py	2010-09-26 18:48:08 +0000
+++ docs/conf.py	2010-09-28 17:34:48 +0000
@@ -211,8 +211,8 @@
 # One entry per manual page. List of tuples
 # (source start file, name, description, authors, manual section).
 man_pages = [
-    ('index', 'drizzle', u'Drizzle Documentation',
-     [u'The Drizzle Developers'], 1)
+    ('clients/drizzledump', 'drizzledump', u'a database backup program',
+     [u'Andrew Hutchings'], 1)
 ]
 
 

=== modified file 'docs/configuration.rst'
--- docs/configuration.rst	2010-09-26 20:42:38 +0000
+++ docs/configuration.rst	2010-09-28 17:34:48 +0000
@@ -28,9 +28,7 @@
 
 Command line options are of the form `--option-name=value`. There are some
 boolean flags, such as `--help` which do not require (nor can accept) an
-option value.
-
-|more| See :ref:`options` for all options that :program:`drizzled`
+option value.  See :ref:`options` for all options that :program:`drizzled`
 supports.
 
 Environment variables are the same as the command line options, except that

=== modified file 'docs/doxygen.h'
--- docs/doxygen.h	2010-08-12 20:27:32 +0000
+++ docs/doxygen.h	2010-09-28 07:50:05 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'docs/include.am'
--- docs/include.am	2010-09-27 06:11:48 +0000
+++ docs/include.am	2010-09-29 04:25:06 +0000
@@ -16,7 +16,6 @@
 	     ${top_srcdir}/docs/*.rst \
 	     ${top_srcdir}/docs/clients/*.rst
 
-
 # Makefile for Sphinx documentation
 #
 
@@ -31,6 +30,14 @@
 
 .PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest
 
+if HAVE_RECENT_SPHINX
+man_MANS+= \
+	   docs/man/drizzledump.1
+DISTCLEANFILES+= docs/man/drizzledump.1
+
+docs/man/drizzledump.1: man
+endif
+
 if HAVE_SPHINX
 sphinx-help:
 	@echo "Please use \`make <target>' where <target> is one of"

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2010-09-27 14:17:47 +0000
+++ drizzled/drizzled.cc	2010-09-28 16:06:47 +0000
@@ -34,6 +34,7 @@
 #include <boost/thread/recursive_mutex.hpp>
 #include <boost/thread/mutex.hpp>
 #include <boost/thread/condition_variable.hpp>
+#include <boost/filesystem.hpp>
 
 #include "drizzled/internal/my_sys.h"
 #include "drizzled/internal/my_bit.h"
@@ -136,6 +137,7 @@
 
 
 using namespace std;
+namespace fs=boost::filesystem;
 namespace po=boost::program_options;
 
 
@@ -222,7 +224,7 @@
 bool volatile abort_loop;
 bool volatile shutdown_in_progress;
 char *opt_scheduler_default;
-char *opt_scheduler= NULL;
+const char *opt_scheduler= NULL;
 
 size_t my_thread_stack_size= 0;
 
@@ -354,13 +356,19 @@
 static void drizzle_init_variables(void);
 static void get_options();
 static const char *get_relative_path(const char *path);
-static void fix_paths(string progname);
+static void fix_paths();
 
 static void usage(void);
 void close_connections(void);
 
+fs::path base_plugin_dir(PKGPLUGINDIR);
+
+po::options_description config_options("Config File Options");
 po::options_description long_options("Kernel Options");
+po::options_description plugin_load_options("Plugin Loading Options");
 po::options_description plugin_options("Plugin Options");
+po::options_description initial_options("Config and Plugin Loading");
+po::options_description full_options("Kernel and Plugin Loading and Plugin");
 vector<string> unknown_options;
 vector<string> defaults_file_list;
 po::variables_map vm;
@@ -674,6 +682,54 @@
   DRIZZLE_CONFIG_NAME, "server", 0, 0
 };
 
+static void find_plugin_dir(string progname)
+{
+  if (progname[0] != FN_LIBCHAR)
+  {
+    /* We have a relative path and need to find the absolute */
+    char working_dir[FN_REFLEN];
+    char *working_dir_ptr= working_dir;
+    working_dir_ptr= getcwd(working_dir_ptr, FN_REFLEN);
+    string new_path(working_dir);
+    if (*(new_path.end()-1) != '/')
+      new_path.push_back('/');
+    if (progname[0] == '.' && progname[1] == '/')
+      new_path.append(progname.substr(2));
+    else
+      new_path.append(progname);
+    progname.swap(new_path);
+  }
+
+  /* Now, trim off the exe name */
+  string progdir(progname.substr(0, progname.rfind(FN_LIBCHAR)+1));
+  if (progdir.rfind(".libs/") != string::npos)
+  {
+    progdir.assign(progdir.substr(0, progdir.rfind(".libs/")));
+  }
+  string testlofile(progdir);
+  testlofile.append("drizzled.lo");
+  string testofile(progdir);
+  testofile.append("drizzled.o");
+  struct stat testfile_stat;
+  if (not (stat(testlofile.c_str(), &testfile_stat) && stat(testofile.c_str(), &testfile_stat)))
+  {
+    /* We are in a source dir! Plugin dir is ../plugin/.libs */
+    size_t last_libchar_pos= progdir.rfind(FN_LIBCHAR,progdir.size()-2)+1;
+    base_plugin_dir= progdir.substr(0,last_libchar_pos);
+    base_plugin_dir /= "plugin";
+    base_plugin_dir /= ".libs";
+  }
+  (void) internal::my_load_path(opt_plugin_dir, fs::path(fs::system_complete(base_plugin_dir)).file_string().c_str(), "");
+}
+
+static void notify_plugin_dir(string in_plugin_dir)
+{
+  if (not in_plugin_dir.empty())
+  {
+    (void) internal::my_load_path(opt_plugin_dir, in_plugin_dir.c_str(), drizzle_home);
+  }
+}
+
 static void check_limits_aii(uint64_t in_auto_increment_increment)
 {
   global_system_variables.auto_increment_increment= 1;
@@ -1082,7 +1138,7 @@
     ifstream input_defaults_file(file_location.c_str());
     
     po::parsed_options file_parsed=
-      po::parse_config_file(input_defaults_file, long_options, true);
+      po::parse_config_file(input_defaults_file, full_options, true);
     vector<string> file_unknown= 
       po::collect_unrecognized(file_parsed.options, po::include_positional);
 
@@ -1121,7 +1177,7 @@
   }
 }
 
-int init_common_variables(int argc, char **argv)
+int init_common_variables(int argc, char **argv, module::Registry &plugins)
 {
   time_t curr_time;
   umask(((~internal::my_umask) & 0666));
@@ -1137,6 +1193,7 @@
 
   drizzle_init_variables();
 
+  find_plugin_dir(argv[0]);
   {
     struct tm tm_tmp;
     localtime_r(&server_start_time,&tm_tmp);
@@ -1168,11 +1225,37 @@
 
   std::string system_config_file_drizzle("drizzled.cnf");
 
-  long_options.add_options()
+  config_options.add_options()
   ("help-extended", po::value<bool>(&opt_help_extended)->default_value(false)->zero_tokens(),
   N_("Display this help and exit after initializing plugins."))
   ("help,?", po::value<bool>(&opt_help)->default_value(false)->zero_tokens(),
   N_("Display this help and exit."))
+  ("no-defaults", po::value<bool>()->default_value(false)->zero_tokens(),
+  N_("Configuration file defaults are not used if no-defaults is set"))
+  ("defaults-file", po::value<vector<string> >()->composing()->notifier(&compose_defaults_file_list),
+   N_("Configuration file to use"))
+  ("config-dir", po::value<string>()->default_value(system_config_dir_drizzle),
+   N_("Base location for config files"))
+  ("plugin-dir", po::value<string>()->notifier(&notify_plugin_dir),
+  N_("Directory for plugins."))
+  ;
+
+  plugin_load_options.add_options()
+  ("plugin-add", po::value<vector<string> >()->composing()->notifier(&compose_plugin_add),
+  N_("Optional comma separated list of plugins to load at startup in addition "
+     "to the default list of plugins. "
+     "[for example: --plugin_add=crc32,logger_gearman]"))    
+  ("plugin-remove", po::value<vector<string> >()->composing()->notifier(&compose_plugin_remove),
+  N_("Optional comma separated list of plugins to not load at startup. Effectively "
+     "removes a plugin from the list of plugins to be loaded. "
+     "[for example: --plugin_remove=crc32,logger_gearman]"))
+  ("plugin-load", po::value<string>()->notifier(&notify_plugin_load)->default_value(PANDORA_PLUGIN_LIST),
+  N_("Optional comma separated list of plugins to load at starup instead of "
+     "the default plugin load list. "
+     "[for example: --plugin_load=crc32,logger_gearman]"))
+  ;
+
+  long_options.add_options()
   ("auto-increment-increment", po::value<uint64_t>(&global_system_variables.auto_increment_increment)->default_value(1)->notifier(&check_limits_aii),
   N_("Auto-increment columns are incremented by this"))
   ("auto-increment-offset", po::value<uint64_t>(&global_system_variables.auto_increment_offset)->default_value(1)->notifier(&check_limits_aio),
@@ -1281,20 +1364,6 @@
      "automatically pick a reasonable value; if set to MAX_TABLES+2, the "
      "optimizer will switch to the original find_best (used for "
      "testing/comparison)."))
-  ("plugin-dir", po::value<string>(),
-  N_("Directory for plugins."))
-  ("plugin-add", po::value<vector<string> >()->composing()->notifier(&compose_plugin_add),
-  N_("Optional comma separated list of plugins to load at startup in addition "
-     "to the default list of plugins. "
-     "[for example: --plugin_add=crc32,logger_gearman]"))    
-  ("plugin-remove", po::value<vector<string> >()->composing()->notifier(&compose_plugin_remove),
-  N_("Optional comma separated list of plugins to not load at startup. Effectively "
-     "removes a plugin from the list of plugins to be loaded. "
-     "[for example: --plugin_remove=crc32,logger_gearman]"))
-  ("plugin-load", po::value<string>()->notifier(&notify_plugin_load)->default_value(PANDORA_PLUGIN_LIST),
-  N_("Optional comma separated list of plugins to load at starup instead of "
-     "the default plugin load list. "
-     "[for example: --plugin_load=crc32,logger_gearman]"))  
   ("preload-buffer-size", po::value<uint64_t>(&global_system_variables.preload_buff_size)->default_value(32*1024L)->notifier(&check_limits_pbs),
   N_("The size of the buffer that is allocated when preloading indexes"))
   ("query-alloc-block-size", 
@@ -1334,19 +1403,18 @@
   po::value<uint64_t>(&global_system_variables.tmp_table_size)->default_value(16*1024*1024L)->notifier(&check_limits_tmp_table_size),
   N_("If an internal in-memory temporary table exceeds this size, Drizzle will"
      " automatically convert it to an on-disk MyISAM table."))
-  ("no-defaults", po::value<bool>()->default_value(false)->zero_tokens(),
-  N_("Configuration file defaults are not used if no-defaults is set"))
-  ("defaults-file", po::value<vector<string> >()->composing()->notifier(&compose_defaults_file_list),
-   N_("Configuration file to use"))
-  ("config-dir", po::value<string>()->default_value(system_config_dir_drizzle),
-   N_("Base location for config files"))
   ;
 
-  // Disable allow_guessing
+  full_options.add(long_options);
+  full_options.add(plugin_load_options);
+
+  initial_options.add(config_options);
+  initial_options.add(plugin_load_options);
+
   int style = po::command_line_style::default_style & ~po::command_line_style::allow_guessing;
-
+  /* Get options about where config files and the like are */
   po::parsed_options parsed= po::command_line_parser(argc, argv).style(style).
-    options(long_options).allow_unregistered().extra_parser(parse_size_arg).run();
+    options(initial_options).allow_unregistered().run();
   unknown_options=
     po::collect_unrecognized(parsed.options, po::include_positional);
 
@@ -1390,8 +1458,52 @@
     }
   }
 
-  po::notify(vm);
   process_defaults_files();
+  /* TODO: here is where we should add a process_env_vars */
+
+  /* We need a notify here so that plugin_init will work properly */
+  po::notify(vm);
+  /* At this point, we've read all the options we need to read from files and
+     collected most of them into unknown options - now let's load everything
+  */
+
+  if (plugin_init(plugins, plugin_options))
+  {
+    errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to initialize plugins\n"));
+    unireg_abort(1);
+  }
+
+  full_options.add(plugin_options);
+
+  vector<string> final_unknown_options;
+  try
+  {
+    po::parsed_options final_parsed=
+      po::command_line_parser(unknown_options).style(style).
+      options(full_options).extra_parser(parse_size_arg).run();
+
+    final_unknown_options=
+      po::collect_unrecognized(final_parsed.options, po::include_positional);
+
+    po::store(final_parsed, vm);
+
+  }
+  catch (po::invalid_command_line_syntax &err)
+  {
+    errmsg_printf(ERRMSG_LVL_ERROR,
+                  _("%s: %s.\n"
+                    "Use --help to get a list of available options\n"),
+                  internal::my_progname, err.what());
+    unireg_abort(1);
+  }
+  catch (po::unknown_option &err)
+  {
+    errmsg_printf(ERRMSG_LVL_ERROR,
+                  _("%s\nUse --help to get a list of available options\n"),
+                  err.what());
+    unireg_abort(1);
+  }
+
   po::notify(vm);
 
   get_options();
@@ -1409,7 +1521,7 @@
     }
   }
 
-  fix_paths(argv[0]);
+  fix_paths();
 
   current_pid= getpid();		/* Save for later ref */
   init_time();				/* Init time-functions (read zone) */
@@ -1429,6 +1541,9 @@
     return 1;                           // Eof of the list
   }
 
+  if (vm.count("scheduler"))
+    opt_scheduler= vm["scheduler"].as<string>().c_str();
+
   if (default_collation_name)
   {
     const CHARSET_INFO * const default_collation= get_charset_by_name(default_collation_name);
@@ -1498,50 +1613,14 @@
   /* Allow storage engine to give real error messages */
   ha_init_errors();
 
-  if (plugin_init(plugins, plugin_options))
-  {
-    errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to initialize plugins\n"));
-    unireg_abort(1);
-  }
-
 
   if (opt_help || opt_help_extended)
     unireg_abort(0);
 
-  vector<string> final_unknown_options;
-  try
-  {
-    // Disable allow_guessing
-    int style = po::command_line_style::default_style & ~po::command_line_style::allow_guessing;
-    po::parsed_options parsed=
-      po::command_line_parser(unknown_options).style(style).
-      options(plugin_options).extra_parser(parse_size_arg).run();
-
-    final_unknown_options=
-      po::collect_unrecognized(parsed.options, po::include_positional);
-
-    po::store(parsed, vm);
-
-  }
-  catch (po::invalid_command_line_syntax &err)
-  {
-    errmsg_printf(ERRMSG_LVL_ERROR,
-                  _("%s: %s.\n"
-                    "Use --help to get a list of available options\n"),
-                  internal::my_progname, err.what());
-    unireg_abort(1);
-  }
-  catch (po::unknown_option &err)
-  {
-    errmsg_printf(ERRMSG_LVL_ERROR,
-                  _("%s\nUse --help to get a list of available options\n"),
-                  err.what());
-    unireg_abort(1);
-  }
-
-  po::notify(vm);
-
-  plugin_finalize(plugins);
+  if (plugin_finalize(plugins))
+  {
+    unireg_abort(1);
+  }
 
   string scheduler_name;
   if (opt_scheduler)
@@ -1906,7 +1985,7 @@
    0, GET_UINT, OPT_ARG, 0, 0, MAX_TABLES+2, 0, 1, 0},
   {"plugin_dir", OPT_PLUGIN_DIR,
    N_("Directory for plugins."),
-   (char**) &opt_plugin_dir_ptr, (char**) &opt_plugin_dir_ptr, 0,
+   NULL, NULL, 0,
    GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"plugin_add", OPT_PLUGIN_ADD,
    N_("Optional comma separated list of plugins to load at startup in addition "
@@ -2031,6 +2110,8 @@
   printf(_("Usage: %s [OPTIONS]\n"), internal::my_progname);
 
   po::options_description all_options("Drizzled Options");
+  all_options.add(config_options);
+  all_options.add(plugin_load_options);
   all_options.add(long_options);
   all_options.add(plugin_options);
   cout << all_options << endl;
@@ -2288,7 +2369,7 @@
 }
 
 
-static void fix_paths(string progname)
+static void fix_paths()
 {
   char buff[FN_REFLEN],*pos,rp_buff[PATH_MAX];
   internal::convert_dirname(drizzle_home,drizzle_home,NULL);
@@ -2310,61 +2391,15 @@
   }
   internal::convert_dirname(language,language,NULL);
   (void) internal::my_load_path(drizzle_home, drizzle_home,""); // Resolve current dir
-  (void) internal::my_load_path(pidfile_name, pidfile_name,
-                                getDataHome().c_str());
-
-  if (opt_plugin_dir_ptr == NULL)
-  {
-    /* No plugin dir has been specified. Figure out where the plugins are */
-    if (progname[0] != FN_LIBCHAR)
-    {
-      /* We have a relative path and need to find the absolute */
-      char working_dir[FN_REFLEN];
-      char *working_dir_ptr= working_dir;
-      working_dir_ptr= getcwd(working_dir_ptr, FN_REFLEN);
-      string new_path(working_dir);
-      if (*(new_path.end()-1) != '/')
-        new_path.push_back('/');
-      if (progname[0] == '.' && progname[1] == '/')
-        new_path.append(progname.substr(2));
-      else
-        new_path.append(progname);
-      progname.swap(new_path);
-    }
-
-    /* Now, trim off the exe name */
-    string progdir(progname.substr(0, progname.rfind(FN_LIBCHAR)+1));
-    if (progdir.rfind(".libs/") != string::npos)
-    {
-      progdir.assign(progdir.substr(0, progdir.rfind(".libs/")));
-    }
-    string testlofile(progdir);
-    testlofile.append("drizzled.lo");
-    string testofile(progdir);
-    testofile.append("drizzled.o");
-    struct stat testfile_stat;
-    if (stat(testlofile.c_str(), &testfile_stat) && stat(testofile.c_str(), &testfile_stat))
-    {
-      /* neither drizzled.lo or drizzled.o exist - we are not in a source dir.
-       * Go on as usual
-       */
-      (void) internal::my_load_path(opt_plugin_dir, get_relative_path(PKGPLUGINDIR),
-                                          drizzle_home);
-    }
-    else
-    {
-      /* We are in a source dir! Plugin dir is ../plugin/.libs */
-      size_t last_libchar_pos= progdir.rfind(FN_LIBCHAR,progdir.size()-2)+1;
-      string source_plugindir(progdir.substr(0,last_libchar_pos));
-      source_plugindir.append("plugin/.libs");
-      (void) internal::my_load_path(opt_plugin_dir, source_plugindir.c_str(), "");
-    }
-  }
-  else
-  {
-    (void) internal::my_load_path(opt_plugin_dir, opt_plugin_dir_ptr, drizzle_home);
-  }
-  opt_plugin_dir_ptr= opt_plugin_dir;
+
+  fs::path pid_file_path(pidfile_name);
+  if (pid_file_path.root_path().string() == "")
+  {
+    pid_file_path= fs::path(getDataHome());
+    pid_file_path /= pidfile_name;
+  }
+  strncpy(pidfile_name, pid_file_path.file_string().c_str(), sizeof(pidfile_name)-1);
+
 
   const char *sharedir= get_relative_path(PKGDATADIR);
   if (internal::test_if_hard_path(sharedir))
@@ -2398,6 +2433,7 @@
       drizzle_tmpdir.append(tmp_string);
     }
 
+    drizzle_tmpdir= fs::path(fs::system_complete(fs::path(drizzle_tmpdir))).file_string();
     assert(drizzle_tmpdir.size());
 
     if (mkdir(drizzle_tmpdir.c_str(), 0777) == -1)

=== modified file 'drizzled/drizzled.h'
--- drizzled/drizzled.h	2010-09-13 17:41:24 +0000
+++ drizzled/drizzled.h	2010-09-27 07:06:04 +0000
@@ -53,7 +53,7 @@
 
 int init_thread_environment();
 int init_server_components(module::Registry &modules);
-int init_common_variables(int argc, char **argv);
+int init_common_variables(int argc, char **argv, module::Registry &modules);
 
 passwd *check_user(const char *user);
 void set_user(const char *user, passwd *user_info_arg);

=== modified file 'drizzled/lock.cc'
--- drizzled/lock.cc	2010-09-22 22:25:29 +0000
+++ drizzled/lock.cc	2010-09-28 05:53:19 +0000
@@ -762,11 +762,13 @@
 }
 
 
-bool wait_for_locked_table_names(Session *session, TableList *table_list)
+static bool wait_for_locked_table_names(Session *session, TableList *table_list)
 {
   bool result= false;
 
-  safe_mutex_assert_owner(LOCK_open.native_handle());
+#if 0
+  assert(ownership of LOCK_open);
+#endif
 
   while (locked_named_table(table_list))
   {
@@ -1012,9 +1014,11 @@
                                 "Waiting to get readlock");
 
     waiting_for_read_lock++;
+    boost::mutex::scoped_lock scopedLock(LOCK_global_read_lock, boost::adopt_lock_t());
     while (protect_against_global_read_lock && !session->killed)
-      pthread_cond_wait(COND_global_read_lock.native_handle(), LOCK_global_read_lock.native_handle());
+      COND_global_read_lock.wait(scopedLock);
     waiting_for_read_lock--;
+    scopedLock.release();
     if (session->killed)
     {
       session->exit_cond(old_message);
@@ -1095,7 +1099,9 @@
     while (must_wait(is_not_commit) && ! session->killed &&
 	   (!abort_on_refresh || session->version == refresh_version))
     {
-      (void) pthread_cond_wait(COND_global_read_lock.native_handle(), LOCK_global_read_lock.native_handle());
+      boost::mutex::scoped_lock scoped(LOCK_global_read_lock, boost::adopt_lock_t());
+      COND_global_read_lock.wait(scoped);
+      scoped.release();
     }
     if (session->killed)
       result=1;
@@ -1145,7 +1151,11 @@
   old_message= session->enter_cond(COND_global_read_lock, LOCK_global_read_lock,
                                    "Waiting for all running commits to finish");
   while (protect_against_global_read_lock && !session->killed)
-    pthread_cond_wait(COND_global_read_lock.native_handle(), LOCK_global_read_lock.native_handle());
+  {
+    boost::mutex::scoped_lock scopedLock(LOCK_global_read_lock, boost::adopt_lock_t());
+    COND_global_read_lock.wait(scopedLock);
+    scopedLock.release();
+  }
   if ((error= test(session->killed)))
     global_read_lock_blocks_commit--; // undo what we did
   else

=== modified file 'drizzled/lock.h'
--- drizzled/lock.h	2010-08-17 01:34:55 +0000
+++ drizzled/lock.h	2010-09-28 00:51:44 +0000
@@ -54,7 +54,6 @@
 
 /* Lock based on name */
 void unlock_table_name(TableList *table_list);
-bool wait_for_locked_table_names(Session *session, TableList *table_list);
 void unlock_table_names(TableList *table_list, TableList *last_table);
 bool lock_table_names_exclusively(Session *session, TableList *table_list);
 

=== modified file 'drizzled/main.cc'
--- drizzled/main.cc	2010-09-26 01:35:56 +0000
+++ drizzled/main.cc	2010-09-28 21:16:18 +0000
@@ -236,11 +236,16 @@
   google::protobuf::SetLogHandler(&GoogleProtoErrorThrower);
 
   /* Function generates error messages before abort */
+  error_handler_hook= my_message_sql;
   /* init_common_variables must get basic settings such as data_home_dir
      and plugin_load_list. */
-  if (init_common_variables(argc, argv))
+  if (init_common_variables(argc, argv, modules))
     unireg_abort(1);				// Will do exit
 
+  /*
+    init signals & alarm
+    After this we can't quit by a simple unireg_abort
+  */
   init_signals();
 
 
@@ -269,9 +274,9 @@
     }
     /* TODO: This is a hack until we can properly support std::string in sys_var*/
     char **data_home_ptr= getDatadirPtr();
-    *data_home_ptr= new char[getDataHome().size()+1] ();
     fs::path full_data_home_path(fs::system_complete(fs::path(getDataHome())));
     std::string full_data_home(full_data_home_path.file_string());
+    *data_home_ptr= new char[full_data_home.size()+1] ();
     memcpy(*data_home_ptr, full_data_home.c_str(), full_data_home.size());
     getDataHomeCatalog()= "./";
     getDataHome()= "../";
@@ -304,11 +309,6 @@
   if (plugin::Listen::setup())
     unireg_abort(1);
 
-  /*
-    init signals & alarm
-    After this we can't quit by a simple unireg_abort
-  */
-  error_handler_hook= my_message_sql;
 
   assert(plugin::num_trx_monitored_objects > 0);
   if (drizzle_rm_tmp_tables() ||
@@ -349,14 +349,16 @@
   COND_thread_count.notify_all();
 
   /* Wait until cleanup is done */
-  LOCK_thread_count.lock();
-  while (!ready_to_exit)
-    pthread_cond_wait(COND_server_end.native_handle(), LOCK_thread_count.native_handle());
-  LOCK_thread_count.unlock();
+  {
+    boost::mutex::scoped_lock scopedLock(LOCK_thread_count);
+    while (!ready_to_exit)
+      COND_server_end.wait(scopedLock);
+  }
 
   clean_up(1);
   module::Registry::shutdown();
   internal::my_end();
+
   return 0;
 }
 

=== modified file 'drizzled/module/loader.cc'
--- drizzled/module/loader.cc	2010-09-21 17:17:33 +0000
+++ drizzled/module/loader.cc	2010-09-27 18:14:40 +0000
@@ -75,7 +75,6 @@
 static PluginOptions opt_plugin_load;
 static PluginOptions opt_plugin_add;
 static PluginOptions opt_plugin_remove;
-char *opt_plugin_dir_ptr;
 char opt_plugin_dir[FN_REFLEN];
 const char *builtin_plugins= PANDORA_BUILTIN_LIST;
 
@@ -448,7 +447,7 @@
   return false;
 }
 
-void plugin_finalize(module::Registry &registry)
+bool plugin_finalize(module::Registry &registry)
 {
 
   /*
@@ -469,9 +468,11 @@
       {
         registry.remove(module);
         delete_module(module);
+        return true;
       }
     }
   }
+  return false;
 }
 
 class PrunePlugin :

=== modified file 'drizzled/plugin.h'
--- drizzled/plugin.h	2010-09-19 23:36:45 +0000
+++ drizzled/plugin.h	2010-09-27 18:14:40 +0000
@@ -46,7 +46,6 @@
 typedef drizzle_lex_string LEX_STRING;
 struct option;
 
-extern char *opt_plugin_dir_ptr;
 extern char opt_plugin_dir[FN_REFLEN];
 
 namespace plugin { class StorageEngine; }
@@ -371,7 +370,7 @@
 
 extern bool plugin_init(module::Registry &registry,
                         boost::program_options::options_description &long_options);
-extern void plugin_finalize(module::Registry &registry);
+extern bool plugin_finalize(module::Registry &registry);
 extern void my_print_help_inc_plugins(option *options);
 extern bool plugin_is_ready(const LEX_STRING *name, int type);
 extern void plugin_sessionvar_init(Session *session);

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2010-09-26 02:09:47 +0000
+++ drizzled/session.cc	2010-09-28 06:27:36 +0000
@@ -307,7 +307,7 @@
   if (mysys_var->current_cond)
   {
     mysys_var->current_mutex->lock();
-    pthread_cond_broadcast(mysys_var->current_cond->native_handle());
+    mysys_var->current_cond->notify_all();
     mysys_var->current_mutex->unlock();
   }
 }
@@ -442,7 +442,7 @@
     if (mysys_var->current_cond && mysys_var->current_mutex)
     {
       mysys_var->current_mutex->lock();
-      pthread_cond_broadcast(mysys_var->current_cond->native_handle());
+      mysys_var->current_cond->notify_all();
       mysys_var->current_mutex->unlock();
     }
   }

=== modified file 'drizzled/set_var.cc'
--- drizzled/set_var.cc	2010-09-26 01:35:56 +0000
+++ drizzled/set_var.cc	2010-09-27 14:34:21 +0000
@@ -202,7 +202,7 @@
                                              &opt_secure_file_priv);
 
 static sys_var_const_str_ptr sys_scheduler(&vars, "scheduler",
-                                           &opt_scheduler);
+                                           (char**)&opt_scheduler);
 
 static sys_var_uint32_t_ptr  sys_server_id(&vars, "server_id", &server_id,
                                            fix_server_id);

=== modified file 'drizzled/set_var.h'
--- drizzled/set_var.h	2010-06-03 03:33:55 +0000
+++ drizzled/set_var.h	2010-09-27 14:34:21 +0000
@@ -83,7 +83,7 @@
 extern bool opt_readonly;
 extern char* opt_secure_file_priv;
 extern char *default_tz_name;
-extern char *opt_scheduler;
+extern const char *opt_scheduler;
 
 uint64_t fix_unsigned(Session *, uint64_t, const struct option *);
 

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2010-09-22 22:25:29 +0000
+++ drizzled/sql_base.cc	2010-09-28 06:27:36 +0000
@@ -200,10 +200,6 @@
                                size_t *length,
                                bool );
 
-#if 0
-static bool reopen_table(Table *table);
-#endif
-
 unsigned char *table_cache_key(const unsigned char *record,
                                size_t *length,
                                bool )
@@ -343,148 +339,152 @@
   bool result= false;
   Session *session= this;
 
-  LOCK_open.lock(); /* Optionally lock for remove tables from open_cahe if not in use */
-
-  if (tables == NULL)
   {
-    refresh_version++;				// Force close of open tables
-
-    unused_tables.clear();
+    LOCK_open.lock(); /* Optionally lock for remove tables from open_cahe if not in use */
+
+    if (tables == NULL)
+    {
+      refresh_version++;				// Force close of open tables
+
+      unused_tables.clear();
+
+      if (wait_for_refresh)
+      {
+        /*
+          Other threads could wait in a loop in open_and_lock_tables(),
+          trying to lock one or more of our tables.
+
+          If they wait for the locks in thr_multi_lock(), their lock
+          request is aborted. They loop in open_and_lock_tables() and
+          enter open_table(). Here they notice the table is refreshed and
+          wait for COND_refresh. Then they loop again in
+          openTablesLock() and this time open_table() succeeds. At
+          this moment, if we (the FLUSH TABLES thread) are scheduled and
+          on another FLUSH TABLES enter close_cached_tables(), they could
+          awake while we sleep below, waiting for others threads (us) to
+          close their open tables. If this happens, the other threads
+          would find the tables unlocked. They would get the locks, one
+          after the other, and could do their destructive work. This is an
+          issue if we have LOCK TABLES in effect.
+
+          The problem is that the other threads passed all checks in
+          open_table() before we refresh the table.
+
+          The fix for this problem is to set some_tables_deleted for all
+          threads with open tables. These threads can still get their
+          locks, but will immediately release them again after checking
+          this variable. They will then loop in openTablesLock()
+          again. There they will wait until we update all tables version
+          below.
+
+          Setting some_tables_deleted is done by remove_table_from_cache()
+          in the other branch.
+
+          In other words (reviewer suggestion): You need this setting of
+          some_tables_deleted for the case when table was opened and all
+          related checks were passed before incrementing refresh_version
+          (which you already have) but attempt to lock the table happened
+          after the call to Session::close_old_data_files() i.e. after removal of
+          current thread locks.
+        */
+        for (TableOpenCache::const_iterator iter= get_open_cache().begin();
+             iter != get_open_cache().end();
+             iter++)
+        {
+          Table *table= (*iter).second;
+          if (table->in_use)
+            table->in_use->some_tables_deleted= false;
+        }
+      }
+    }
+    else
+    {
+      bool found= false;
+      for (TableList *table= tables; table; table= table->next_local)
+      {
+        TableIdentifier identifier(table->db, table->table_name);
+        if (remove_table_from_cache(session, identifier,
+                                    RTFC_OWNED_BY_Session_FLAG))
+        {
+          found= true;
+        }
+      }
+      if (!found)
+        wait_for_refresh= false;			// Nothing to wait for
+    }
 
     if (wait_for_refresh)
     {
       /*
-        Other threads could wait in a loop in open_and_lock_tables(),
-        trying to lock one or more of our tables.
-
-        If they wait for the locks in thr_multi_lock(), their lock
-        request is aborted. They loop in open_and_lock_tables() and
-        enter open_table(). Here they notice the table is refreshed and
-        wait for COND_refresh. Then they loop again in
-        openTablesLock() and this time open_table() succeeds. At
-        this moment, if we (the FLUSH TABLES thread) are scheduled and
-        on another FLUSH TABLES enter close_cached_tables(), they could
-        awake while we sleep below, waiting for others threads (us) to
-        close their open tables. If this happens, the other threads
-        would find the tables unlocked. They would get the locks, one
-        after the other, and could do their destructive work. This is an
-        issue if we have LOCK TABLES in effect.
-
-        The problem is that the other threads passed all checks in
-        open_table() before we refresh the table.
-
-        The fix for this problem is to set some_tables_deleted for all
-        threads with open tables. These threads can still get their
-        locks, but will immediately release them again after checking
-        this variable. They will then loop in openTablesLock()
-        again. There they will wait until we update all tables version
-        below.
-
-        Setting some_tables_deleted is done by remove_table_from_cache()
-        in the other branch.
-
-        In other words (reviewer suggestion): You need this setting of
-        some_tables_deleted for the case when table was opened and all
-        related checks were passed before incrementing refresh_version
-        (which you already have) but attempt to lock the table happened
-        after the call to Session::close_old_data_files() i.e. after removal of
-        current thread locks.
-      */
-      for (TableOpenCache::const_iterator iter= get_open_cache().begin();
-           iter != get_open_cache().end();
-           iter++)
-      {
-        Table *table= (*iter).second;
-        if (table->in_use)
-          table->in_use->some_tables_deleted= false;
-      }
-    }
-  }
-  else
-  {
-    bool found= false;
-    for (TableList *table= tables; table; table= table->next_local)
-    {
-      TableIdentifier identifier(table->db, table->table_name);
-      if (remove_table_from_cache(session, identifier,
-                                  RTFC_OWNED_BY_Session_FLAG))
-      {
-        found= true;
-      }
-    }
-    if (!found)
-      wait_for_refresh= false;			// Nothing to wait for
-  }
-
-  if (wait_for_refresh)
-  {
-    /*
-      If there is any table that has a lower refresh_version, wait until
-      this is closed (or this thread is killed) before returning
-    */
-    session->mysys_var->current_mutex= &LOCK_open;
-    session->mysys_var->current_cond= &COND_refresh;
-    session->set_proc_info("Flushing tables");
-
-    session->close_old_data_files();
-
-    bool found= true;
-    /* Wait until all threads has closed all the tables we had locked */
-    while (found && ! session->killed)
-    {
-      found= false;
-      for (TableOpenCache::const_iterator iter= get_open_cache().begin();
-           iter != get_open_cache().end();
-           iter++)
-      {
-        Table *table= (*iter).second;
-        /* Avoid a self-deadlock. */
-        if (table->in_use == session)
-          continue;
+        If there is any table that has a lower refresh_version, wait until
+        this is closed (or this thread is killed) before returning
+      */
+      session->mysys_var->current_mutex= &LOCK_open;
+      session->mysys_var->current_cond= &COND_refresh;
+      session->set_proc_info("Flushing tables");
+
+      session->close_old_data_files();
+
+      bool found= true;
+      /* Wait until all threads has closed all the tables we had locked */
+      while (found && ! session->killed)
+      {
+        found= false;
+        for (TableOpenCache::const_iterator iter= get_open_cache().begin();
+             iter != get_open_cache().end();
+             iter++)
+        {
+          Table *table= (*iter).second;
+          /* Avoid a self-deadlock. */
+          if (table->in_use == session)
+            continue;
+          /*
+            Note that we wait here only for tables which are actually open, and
+            not for placeholders with Table::open_placeholder set. Waiting for
+            latter will cause deadlock in the following scenario, for example:
+
+            conn1-> lock table t1 write;
+            conn2-> lock table t2 write;
+            conn1-> flush tables;
+            conn2-> flush tables;
+
+            It also does not make sense to wait for those of placeholders that
+            are employed by CREATE TABLE as in this case table simply does not
+            exist yet.
+          */
+          if (table->needs_reopen_or_name_lock() && (table->db_stat ||
+                                                     (table->open_placeholder && wait_for_placeholders)))
+          {
+            found= true;
+            boost::mutex::scoped_lock scoped(LOCK_open, boost::adopt_lock_t());
+            COND_refresh.wait(scoped);
+            scoped.release();
+            break;
+          }
+        }
+      }
+      /*
+        No other thread has the locked tables open; reopen them and get the
+        old locks. This should always succeed (unless some external process
+        has removed the tables)
+      */
+      result= session->reopen_tables(true, true);
+
+      /* Set version for table */
+      for (Table *table= session->open_tables; table ; table= table->getNext())
+      {
         /*
-          Note that we wait here only for tables which are actually open, and
-          not for placeholders with Table::open_placeholder set. Waiting for
-          latter will cause deadlock in the following scenario, for example:
-
-          conn1-> lock table t1 write;
-          conn2-> lock table t2 write;
-          conn1-> flush tables;
-          conn2-> flush tables;
-
-          It also does not make sense to wait for those of placeholders that
-          are employed by CREATE TABLE as in this case table simply does not
-          exist yet.
+          Preserve the version (0) of write locked tables so that a impending
+          global read lock won't sneak in.
         */
-        if (table->needs_reopen_or_name_lock() && (table->db_stat ||
-                                                   (table->open_placeholder && wait_for_placeholders)))
-        {
-          found= true;
-          pthread_cond_wait(COND_refresh.native_handle(),LOCK_open.native_handle());
-          break;
-        }
+        if (table->reginfo.lock_type < TL_WRITE_ALLOW_WRITE)
+          table->getMutableShare()->refreshVersion();
       }
     }
-    /*
-      No other thread has the locked tables open; reopen them and get the
-      old locks. This should always succeed (unless some external process
-      has removed the tables)
-    */
-    result= session->reopen_tables(true, true);
 
-    /* Set version for table */
-    for (Table *table= session->open_tables; table ; table= table->getNext())
-    {
-      /*
-        Preserve the version (0) of write locked tables so that a impending
-        global read lock won't sneak in.
-      */
-      if (table->reginfo.lock_type < TL_WRITE_ALLOW_WRITE)
-        table->getMutableShare()->refreshVersion();
-    }
+    LOCK_open.unlock();
   }
 
-  LOCK_open.unlock();
-
   if (wait_for_refresh)
   {
     boost::mutex::scoped_lock scopedLock(session->mysys_var->mutex);
@@ -948,21 +948,23 @@
   mysys_var->current_cond= &cond;
   saved_proc_info= get_proc_info();
   set_proc_info("Waiting for table");
-  if (!killed)
-    (void) pthread_cond_wait(cond.native_handle(), mutex.native_handle());
-
-  /*
-    We must unlock mutex first to avoid deadlock becasue conditions are
-    sent to this thread by doing locks in the following order:
-    lock(mysys_var->mutex)
-    lock(mysys_var->current_mutex)
-
-    One by effect of this that one can only use wait_for_condition with
-    condition variables that are guranteed to not disapper (freed) even if this
-    mutex is unlocked
-  */
-
-  pthread_mutex_unlock(mutex.native_handle());
+  {
+    /*
+      We must unlock mutex first to avoid deadlock becasue conditions are
+      sent to this thread by doing locks in the following order:
+      lock(mysys_var->mutex)
+      lock(mysys_var->current_mutex)
+
+      One by effect of this that one can only use wait_for_condition with
+      condition variables that are guranteed to not disapper (freed) even if this
+      mutex is unlocked
+    */
+    boost::mutex::scoped_lock scopedLock(mutex, boost::adopt_lock_t());
+    if (not killed)
+    {
+      cond.wait(scopedLock);
+    }
+  }
   boost::mutex::scoped_lock (mysys_var->mutex);
   mysys_var->current_mutex= 0;
   mysys_var->current_cond= 0;
@@ -1204,6 +1206,7 @@
     same name. This block implements the behaviour.
     TODO -> move this block into a separate function.
   */
+  bool reset= false;
   for (table= temporary_tables; table ; table=table->getNext())
   {
     if (table->getShare()->getCacheKey() == key)
@@ -1220,231 +1223,236 @@
         return NULL;
       }
       table->query_id= getQueryId();
-      goto reset;
-    }
-  }
-
-  if (flags & DRIZZLE_OPEN_TEMPORARY_ONLY)
-  {
-    my_error(ER_NO_SUCH_TABLE, MYF(0), table_list->db, table_list->table_name);
-    return NULL;
-  }
-
-  /*
-    If it's the first table from a list of tables used in a query,
-    remember refresh_version (the version of open_cache state).
-    If the version changes while we're opening the remaining tables,
-    we will have to back off, close all the tables opened-so-far,
-    and try to reopen them.
-
-    Note-> refresh_version is currently changed only during FLUSH TABLES.
-  */
-  if (!open_tables)
-  {
-    version= refresh_version;
-  }
-  else if ((version != refresh_version) &&
-           ! (flags & DRIZZLE_LOCK_IGNORE_FLUSH))
-  {
-    /* Someone did a refresh while thread was opening tables */
-    if (refresh)
-      *refresh= true;
-
-    return NULL;
-  }
-
-  /*
-    Before we test the global cache, we test our local session cache.
-  */
-  if (cached_table)
-  {
-    assert(false); /* Not implemented yet */
-  }
-
-  /*
-    Non pre-locked/LOCK TABLES mode, and the table is not temporary:
-    this is the normal use case.
-    Now we should:
-    - try to find the table in the table cache.
-    - if one of the discovered Table instances is name-locked
-    (table->getShare()->version == 0) back off -- we have to wait
-    until no one holds a name lock on the table.
-    - if there is no such Table in the name cache, read the table definition
-    and insert it into the cache.
-    We perform all of the above under LOCK_open which currently protects
-    the open cache (also known as table cache) and table definitions stored
-    on disk.
-  */
-
-  LOCK_open.lock(); /* Lock for FLUSH TABLES for open table */
-
-  /*
-    Actually try to find the table in the open_cache.
-    The cache may contain several "Table" instances for the same
-    physical table. The instances that are currently "in use" by
-    some thread have their "in_use" member != NULL.
-    There is no good reason for having more than one entry in the
-    hash for the same physical table, except that we use this as
-    an implicit "pending locks queue" - see
-    wait_for_locked_table_names for details.
-  */
-  ppp= get_open_cache().equal_range(key);
-
-  table= NULL;
-  for (TableOpenCache::const_iterator iter= ppp.first;
-       iter != ppp.second; ++iter, table= NULL)
-  {
-    table= (*iter).second;
-
-    if (not table->in_use)
+      reset= true;
       break;
+    }
+  }
+
+  if (not reset)
+  {
+    if (flags & DRIZZLE_OPEN_TEMPORARY_ONLY)
+    {
+      my_error(ER_NO_SUCH_TABLE, MYF(0), table_list->db, table_list->table_name);
+      return NULL;
+    }
+
     /*
-      Here we flush tables marked for flush.
-      Normally, table->getShare()->version contains the value of
-      refresh_version from the moment when this table was
-      (re-)opened and added to the cache.
-      If since then we did (or just started) FLUSH TABLES
-      statement, refresh_version has been increased.
-      For "name-locked" Table instances, table->getShare()->version is set
-      to 0 (see lock_table_name for details).
-      In case there is a pending FLUSH TABLES or a name lock, we
-      need to back off and re-start opening tables.
-      If we do not back off now, we may dead lock in case of lock
-      order mismatch with some other thread:
-      c1-> name lock t1; -- sort of exclusive lock
-      c2-> open t2;      -- sort of shared lock
-      c1-> name lock t2; -- blocks
-      c2-> open t1; -- blocks
+      If it's the first table from a list of tables used in a query,
+      remember refresh_version (the version of open_cache state).
+      If the version changes while we're opening the remaining tables,
+      we will have to back off, close all the tables opened-so-far,
+      and try to reopen them.
+
+      Note-> refresh_version is currently changed only during FLUSH TABLES.
     */
-    if (table->needs_reopen_or_name_lock())
-    {
-      if (flags & DRIZZLE_LOCK_IGNORE_FLUSH)
-      {
-        /* Force close at once after usage */
-        version= table->getShare()->getVersion();
-        continue;
-      }
-
-      /* Avoid self-deadlocks by detecting self-dependencies. */
-      if (table->open_placeholder && table->in_use == this)
-      {
-        LOCK_open.unlock();
-        my_error(ER_UPDATE_TABLE_USED, MYF(0), table->getMutableShare()->getTableName());
-        return NULL;
-      }
-
-      /*
-        Back off, part 1: mark the table as "unused" for the
-        purpose of name-locking by setting table->db_stat to 0. Do
-        that only for the tables in this thread that have an old
-        table->getShare()->version (this is an optimization (?)).
-        table->db_stat == 0 signals wait_for_locked_table_names
-        that the tables in question are not used any more. See
-        table_is_used call for details.
-      */
-      close_old_data_files(false, false);
-
-      /*
-        Back-off part 2: try to avoid "busy waiting" on the table:
-        if the table is in use by some other thread, we suspend
-        and wait till the operation is complete: when any
-        operation that juggles with table->getShare()->version completes,
-        it broadcasts COND_refresh condition variable.
-        If 'old' table we met is in use by current thread we return
-        without waiting since in this situation it's this thread
-        which is responsible for broadcasting on COND_refresh
-        (and this was done already in Session::close_old_data_files()).
-        Good example of such situation is when we have statement
-        that needs two instances of table and FLUSH TABLES comes
-        after we open first instance but before we open second
-        instance.
-      */
-      if (table->in_use != this)
-      {
-        /* wait_for_conditionwill unlock LOCK_open for us */
-        wait_for_condition(LOCK_open, COND_refresh);
-      }
-      else
-      {
-        LOCK_open.unlock();
-      }
-      /*
-        There is a refresh in progress for this table.
-        Signal the caller that it has to try again.
-      */
+    if (!open_tables)
+    {
+      version= refresh_version;
+    }
+    else if ((version != refresh_version) &&
+             ! (flags & DRIZZLE_LOCK_IGNORE_FLUSH))
+    {
+      /* Someone did a refresh while thread was opening tables */
       if (refresh)
         *refresh= true;
-      return NULL;
-    }
-  }
-  if (table)
-  {
-    unused_tables.unlink(table);
-    table->in_use= this;
-  }
-  else
-  {
-    /* Insert a new Table instance into the open cache */
-    int error;
-    /* Free cache if too big */
-    unused_tables.cull();
-
-    if (table_list->isCreate())
-    {
-      TableIdentifier  lock_table_identifier(table_list->db, table_list->table_name, message::Table::STANDARD);
-
-      if (not plugin::StorageEngine::doesTableExist(*this, lock_table_identifier))
-      {
-        /*
-          Table to be created, so we need to create placeholder in table-cache.
-        */
-        if (!(table= table_cache_insert_placeholder(table_list->db, table_list->table_name)))
-        {
-          LOCK_open.unlock();
-          return NULL;
-        }
-        /*
-          Link placeholder to the open tables list so it will be automatically
-          removed once tables are closed. Also mark it so it won't be ignored
-          by other trying to take name-lock.
-        */
-        table->open_placeholder= true;
-        table->setNext(open_tables);
-        open_tables= table;
-        LOCK_open.unlock();
-
-        return table ;
-      }
-      /* Table exists. Let us try to open it. */
-    }
-
-    /* make a new table */
-    table= new Table;
-    if (table == NULL)
-    {
-      LOCK_open.unlock();
-      return NULL;
-    }
-
-    error= open_unireg_entry(this, table, alias, identifier);
-    if (error != 0)
-    {
-      delete table;
-      LOCK_open.unlock();
-      return NULL;
-    }
-    (void)add_table(table);
-  }
-
-  LOCK_open.unlock();
-  if (refresh)
-  {
-    table->setNext(open_tables); /* Link into simple list */
-    open_tables= table;
-  }
-  table->reginfo.lock_type= TL_READ; /* Assume read */
-
-reset:
+
+      return NULL;
+    }
+
+    /*
+      Before we test the global cache, we test our local session cache.
+    */
+    if (cached_table)
+    {
+      assert(false); /* Not implemented yet */
+    }
+
+    /*
+      Non pre-locked/LOCK TABLES mode, and the table is not temporary:
+      this is the normal use case.
+      Now we should:
+      - try to find the table in the table cache.
+      - if one of the discovered Table instances is name-locked
+      (table->getShare()->version == 0) back off -- we have to wait
+      until no one holds a name lock on the table.
+      - if there is no such Table in the name cache, read the table definition
+      and insert it into the cache.
+      We perform all of the above under LOCK_open which currently protects
+      the open cache (also known as table cache) and table definitions stored
+      on disk.
+    */
+
+    {
+      LOCK_open.lock(); /* Lock for FLUSH TABLES for open table */
+
+      /*
+        Actually try to find the table in the open_cache.
+        The cache may contain several "Table" instances for the same
+        physical table. The instances that are currently "in use" by
+        some thread have their "in_use" member != NULL.
+        There is no good reason for having more than one entry in the
+        hash for the same physical table, except that we use this as
+        an implicit "pending locks queue" - see
+        wait_for_locked_table_names for details.
+      */
+      ppp= get_open_cache().equal_range(key);
+
+      table= NULL;
+      for (TableOpenCache::const_iterator iter= ppp.first;
+           iter != ppp.second; ++iter, table= NULL)
+      {
+        table= (*iter).second;
+
+        if (not table->in_use)
+          break;
+        /*
+          Here we flush tables marked for flush.
+          Normally, table->getShare()->version contains the value of
+          refresh_version from the moment when this table was
+          (re-)opened and added to the cache.
+          If since then we did (or just started) FLUSH TABLES
+          statement, refresh_version has been increased.
+          For "name-locked" Table instances, table->getShare()->version is set
+          to 0 (see lock_table_name for details).
+          In case there is a pending FLUSH TABLES or a name lock, we
+          need to back off and re-start opening tables.
+          If we do not back off now, we may dead lock in case of lock
+          order mismatch with some other thread:
+          c1-> name lock t1; -- sort of exclusive lock
+          c2-> open t2;      -- sort of shared lock
+          c1-> name lock t2; -- blocks
+          c2-> open t1; -- blocks
+        */
+        if (table->needs_reopen_or_name_lock())
+        {
+          if (flags & DRIZZLE_LOCK_IGNORE_FLUSH)
+          {
+            /* Force close at once after usage */
+            version= table->getShare()->getVersion();
+            continue;
+          }
+
+          /* Avoid self-deadlocks by detecting self-dependencies. */
+          if (table->open_placeholder && table->in_use == this)
+          {
+            LOCK_open.unlock();
+            my_error(ER_UPDATE_TABLE_USED, MYF(0), table->getMutableShare()->getTableName());
+            return NULL;
+          }
+
+          /*
+            Back off, part 1: mark the table as "unused" for the
+            purpose of name-locking by setting table->db_stat to 0. Do
+            that only for the tables in this thread that have an old
+            table->getShare()->version (this is an optimization (?)).
+            table->db_stat == 0 signals wait_for_locked_table_names
+            that the tables in question are not used any more. See
+            table_is_used call for details.
+          */
+          close_old_data_files(false, false);
+
+          /*
+            Back-off part 2: try to avoid "busy waiting" on the table:
+            if the table is in use by some other thread, we suspend
+            and wait till the operation is complete: when any
+            operation that juggles with table->getShare()->version completes,
+            it broadcasts COND_refresh condition variable.
+            If 'old' table we met is in use by current thread we return
+            without waiting since in this situation it's this thread
+            which is responsible for broadcasting on COND_refresh
+            (and this was done already in Session::close_old_data_files()).
+            Good example of such situation is when we have statement
+            that needs two instances of table and FLUSH TABLES comes
+            after we open first instance but before we open second
+            instance.
+          */
+          if (table->in_use != this)
+          {
+            /* wait_for_conditionwill unlock LOCK_open for us */
+            wait_for_condition(LOCK_open, COND_refresh);
+          }
+          else
+          {
+            LOCK_open.unlock();
+          }
+          /*
+            There is a refresh in progress for this table.
+            Signal the caller that it has to try again.
+          */
+          if (refresh)
+            *refresh= true;
+          return NULL;
+        }
+      }
+      if (table)
+      {
+        unused_tables.unlink(table);
+        table->in_use= this;
+      }
+      else
+      {
+        /* Insert a new Table instance into the open cache */
+        int error;
+        /* Free cache if too big */
+        unused_tables.cull();
+
+        if (table_list->isCreate())
+        {
+          TableIdentifier  lock_table_identifier(table_list->db, table_list->table_name, message::Table::STANDARD);
+
+          if (not plugin::StorageEngine::doesTableExist(*this, lock_table_identifier))
+          {
+            /*
+              Table to be created, so we need to create placeholder in table-cache.
+            */
+            if (!(table= table_cache_insert_placeholder(table_list->db, table_list->table_name)))
+            {
+              LOCK_open.unlock();
+              return NULL;
+            }
+            /*
+              Link placeholder to the open tables list so it will be automatically
+              removed once tables are closed. Also mark it so it won't be ignored
+              by other trying to take name-lock.
+            */
+            table->open_placeholder= true;
+            table->setNext(open_tables);
+            open_tables= table;
+            LOCK_open.unlock();
+
+            return table ;
+          }
+          /* Table exists. Let us try to open it. */
+        }
+
+        /* make a new table */
+        table= new Table;
+        if (table == NULL)
+        {
+          LOCK_open.unlock();
+          return NULL;
+        }
+
+        error= open_unireg_entry(this, table, alias, identifier);
+        if (error != 0)
+        {
+          delete table;
+          LOCK_open.unlock();
+          return NULL;
+        }
+        (void)add_table(table);
+      }
+
+      LOCK_open.unlock();
+    }
+    if (refresh)
+    {
+      table->setNext(open_tables); /* Link into simple list */
+      open_tables= table;
+    }
+    table->reginfo.lock_type= TL_READ; /* Assume read */
+
+  }
   assert(table->getShare()->getTableCount() > 0 || table->getShare()->getType() != message::Table::STANDARD);
 
   if (lex->need_correct_ident())
@@ -1482,97 +1490,6 @@
 }
 
 
-#if 0
-/*
-  Reopen an table because the definition has changed.
-
-  SYNOPSIS
-  reopen_table()
-  table	Table object
-
-  NOTES
-  The data cursor for the table is already closed and the share is released
-  The table has a 'dummy' share that mainly contains database and table name.
-
-  RETURN
-  0  ok
-  1  error. The old table object is not changed.
-*/
-
-bool reopen_table(Table *table)
-{
-  Table tmp;
-  bool error= 1;
-  Field **field;
-  uint32_t key,part;
-  TableList table_list;
-  Session *session= table->in_use;
-
-  assert(table->getShare()->ref_count == 0);
-  assert(!table->sort.io_cache);
-
-#ifdef EXTRA_DEBUG
-  if (table->db_stat)
-    errmsg_printf(ERRMSG_LVL_ERROR, _("Table %s had a open data Cursor in reopen_table"),
-                  table->alias);
-#endif
-  table_list.db=         const_cast<char *>(table->getShare()->getSchemaName());
-  table_list.table_name= table->getShare()->getTableName();
-  table_list.table=      table;
-
-  if (wait_for_locked_table_names(session, &table_list))
-    return true;                             // Thread was killed
-
-  if (open_unireg_entry(session, &tmp, &table_list,
-                        table->alias,
-                        table->getShare()->getCacheKey(),
-                        table->getShare()->getCacheKeySize()))
-    goto end;
-
-  /* This list copies variables set by open_table */
-  tmp.tablenr=		table->tablenr;
-  tmp.used_fields=	table->used_fields;
-  tmp.const_table=	table->const_table;
-  tmp.null_row=		table->null_row;
-  tmp.maybe_null=	table->maybe_null;
-  tmp.status=		table->status;
-
-  /* Get state */
-  tmp.in_use=    	session;
-  tmp.reginfo.lock_type=table->reginfo.lock_type;
-
-  /* Replace table in open list */
-  tmp.next=		table->next;
-  tmp.prev=		table->prev;
-
-  if (table->cursor)
-    table->delete_table(true);		// close cursor, free everything
-
-  *table= tmp;
-  table->default_column_bitmaps();
-  table->cursor->change_table_ptr(table, table->s);
-
-  assert(table->alias != 0);
-  for (field=table->field ; *field ; field++)
-  {
-    (*field)->table= (*field)->orig_table= table;
-    (*field)->table_name= &table->alias;
-  }
-  for (key=0 ; key < table->getShare()->keys ; key++)
-  {
-    for (part=0 ; part < table->key_info[key].usable_key_parts ; part++)
-      table->key_info[key].key_part[part].field->table= table;
-  }
-
-  broadcast_refresh();
-  error= false;
-
-end:
-  return(error);
-}
-#endif
-
-
 /**
   Close all instances of a table open by this thread and replace
   them with exclusive name-locks.
@@ -4591,10 +4508,13 @@
       {
         dropping_tables++;
         if (likely(signalled))
-          (void) pthread_cond_wait(COND_refresh.native_handle(), LOCK_open.native_handle());
+        {
+          boost::mutex::scoped_lock scoped(LOCK_open, boost::adopt_lock_t());
+          COND_refresh.wait(scoped);
+          scoped.release();
+        }
         else
         {
-          struct timespec abstime;
           /*
             It can happen that another thread has opened the
             table but has not yet locked any table at all. Since
@@ -4605,8 +4525,12 @@
             and then we retry another loop in the
             remove_table_from_cache routine.
           */
-          set_timespec(abstime, 10);
-          pthread_cond_timedwait(COND_refresh.native_handle(), LOCK_open.native_handle(), &abstime);
+          boost::xtime xt; 
+          xtime_get(&xt, boost::TIME_UTC); 
+          xt.sec += 10; 
+          boost::mutex::scoped_lock scoped(LOCK_open, boost::adopt_lock_t());
+          COND_refresh.timed_wait(scoped, xt);
+          scoped.release();
         }
         dropping_tables--;
         continue;

=== modified file 'drizzled/table_share.cc'
--- drizzled/table_share.cc	2010-09-22 22:29:55 +0000
+++ drizzled/table_share.cc	2010-09-28 07:23:27 +0000
@@ -785,7 +785,9 @@
     while (waiting_on_cond)
     {
       cond.notify_all();
-      pthread_cond_wait(cond.native_handle(), mutex.native_handle());
+      boost::mutex::scoped_lock scoped(mutex, boost::adopt_lock_t());
+      cond.wait(scoped);
+      scoped.release();
     }
     /* No thread refers to this anymore */
     mutex.unlock();

=== modified file 'drizzled/thr_lock.cc'
--- drizzled/thr_lock.cc	2010-09-22 22:25:29 +0000
+++ drizzled/thr_lock.cc	2010-09-28 05:20:24 +0000
@@ -78,6 +78,8 @@
 
 #include <drizzled/util/test.h>
 
+#include <boost/interprocess/sync/lock_options.hpp>
+
 using namespace std;
 
 namespace drizzled
@@ -152,7 +154,6 @@
   internal::st_my_thread_var *thread_var= session->getThreadVar();
 
   boost::condition_variable *cond= &thread_var->suspend;
-  struct timespec wait_timeout;
   enum enum_thr_lock_result result= THR_LOCK_ABORTED;
   bool can_deadlock= test(data->owner->info->n_cursors);
 
@@ -170,13 +171,26 @@
   thread_var->current_cond=  &thread_var->suspend;
   data->cond= &thread_var->suspend;;
 
-  if (can_deadlock)
-    set_timespec(wait_timeout, table_lock_wait_timeout);
   while (!thread_var->abort || in_wait_list)
   {
-    int rc= (can_deadlock ?
-             pthread_cond_timedwait(cond->native_handle(), data->lock->native_handle()->native_handle(), &wait_timeout) :
-             pthread_cond_wait(cond->native_handle(), data->lock->native_handle()->native_handle()));
+    boost::mutex::scoped_lock scoped(*data->lock->native_handle(), boost::adopt_lock_t());
+
+    if (can_deadlock)
+    {
+      boost::xtime xt; 
+      xtime_get(&xt, boost::TIME_UTC); 
+      xt.sec += table_lock_wait_timeout; 
+      if (not cond->timed_wait(scoped, xt))
+      {
+        result= THR_LOCK_WAIT_TIMEOUT;
+        scoped.release();
+        break;
+      }
+    }
+    else
+    {
+      cond->wait(scoped);
+    }
     /*
       We must break the wait if one of the following occurs:
       - the connection has been aborted (!thread_var->abort), but
@@ -192,13 +206,10 @@
     */
     if (data->cond == NULL)
     {
-      break;
-    }
-    if (rc == ETIMEDOUT || rc == ETIME)
-    {
-      result= THR_LOCK_WAIT_TIMEOUT;
-      break;
-    }
+      scoped.release();
+      break;
+    }
+    scoped.release();
   }
   if (data->cond || data->type == TL_UNLOCK)
   {

=== modified file 'drizzled/transaction_services.cc'
--- drizzled/transaction_services.cc	2010-09-27 17:55:50 +0000
+++ drizzled/transaction_services.cc	2010-09-28 01:43:36 +0000
@@ -1426,17 +1426,7 @@
       field_metadata->set_type(message::internalFieldTypeToFieldProtoType(current_field->type()));
     }
 
-    /*
-     * The below really should be moved into the Field API and Record API.  But for now
-     * we do this crazy pointer fiddling to figure out if the current field
-     * has been updated in the supplied record raw byte pointers.
-     */
-    const unsigned char *old_ptr= (const unsigned char *) old_record + (ptrdiff_t) (current_field->ptr - in_table->getInsertRecord()); 
-    const unsigned char *new_ptr= (const unsigned char *) new_record + (ptrdiff_t) (current_field->ptr - in_table->getInsertRecord()); 
-
-    uint32_t field_length= current_field->pack_length(); /** @TODO This isn't always correct...check varchar diffs. */
-
-    if (memcmp(old_ptr, new_ptr, field_length) != 0)
+    if (isFieldUpdated(current_field, in_table, old_record, new_record))
     {
       /* Field is changed from old to new */
       field_metadata= header->add_set_field_metadata();
@@ -1479,17 +1469,8 @@
      * UPDATE t1 SET counter = counter + 1 WHERE id IN (1,2);
      *
      * We will generate two UpdateRecord messages with different set_value byte arrays.
-     *
-     * The below really should be moved into the Field API and Record API.  But for now
-     * we do this crazy pointer fiddling to figure out if the current field
-     * has been updated in the supplied record raw byte pointers.
      */
-    const unsigned char *old_ptr= (const unsigned char *) old_record + (ptrdiff_t) (current_field->ptr - in_table->getInsertRecord()); 
-    const unsigned char *new_ptr= (const unsigned char *) new_record + (ptrdiff_t) (current_field->ptr - in_table->getInsertRecord()); 
-
-    uint32_t field_length= current_field->pack_length(); /** @TODO This isn't always correct...check varchar diffs. */
-
-    if (memcmp(old_ptr, new_ptr, field_length) != 0)
+    if (isFieldUpdated(current_field, in_table, old_record, new_record))
     {
       /* Store the original "read bit" for this field */
       bool is_read_set= current_field->isReadSet();
@@ -1541,6 +1522,47 @@
   }
 }
 
+bool TransactionServices::isFieldUpdated(Field *current_field,
+                                         Table *in_table,
+                                         const unsigned char *old_record,
+                                         const unsigned char *new_record)
+{
+  /*
+   * The below really should be moved into the Field API and Record API.  But for now
+   * we do this crazy pointer fiddling to figure out if the current field
+   * has been updated in the supplied record raw byte pointers.
+   */
+  const unsigned char *old_ptr= (const unsigned char *) old_record + (ptrdiff_t) (current_field->ptr - in_table->getInsertRecord());
+  const unsigned char *new_ptr= (const unsigned char *) new_record + (ptrdiff_t) (current_field->ptr - in_table->getInsertRecord());
+
+  uint32_t field_length= current_field->pack_length(); /** @TODO This isn't always correct...check varchar diffs. */
+
+  bool old_value_is_null= current_field->is_null_in_record(old_record);
+  bool new_value_is_null= current_field->is_null_in_record(new_record);
+
+  bool isUpdated= false;
+  if (old_value_is_null != new_value_is_null)
+  {
+    if ((old_value_is_null) && (! new_value_is_null)) /* old value is NULL, new value is non NULL */
+    {
+      isUpdated= true;
+    }
+    else if ((! old_value_is_null) && (new_value_is_null)) /* old value is non NULL, new value is NULL */
+    {
+      isUpdated= true;
+    }
+  }
+
+  if (! isUpdated)
+  {
+    if (memcmp(old_ptr, new_ptr, field_length) != 0)
+    {
+      isUpdated= true;
+    }
+  }
+  return isUpdated;
+}  
+
 message::Statement &TransactionServices::getDeleteStatement(Session *in_session,
                                                             Table *in_table,
                                                             uint32_t *next_segment_id)

=== modified file 'drizzled/transaction_services.h'
--- drizzled/transaction_services.h	2010-08-28 01:11:17 +0000
+++ drizzled/transaction_services.h	2010-09-28 01:41:30 +0000
@@ -41,7 +41,8 @@
 
 class Session;
 class NamedSavepoint;
-
+class Field;
+ 
 /**
  * This is a class which manages the XA transaction processing
  * in the server
@@ -428,6 +429,19 @@
   }
 private:
   atomic<TransactionId> current_transaction_id;
+
+  /**
+   * Checks if a field has been updated 
+   *
+   * @param current_field Pointer to the field to check if it is updated 
+   * @in_table Pointer to the Table containing update information
+   * @param old_record Pointer to the raw bytes representing the old record/row
+   * @param new_record Pointer to the raw bytes representing the new record/row
+   */
+  bool isFieldUpdated(Field *current_field,
+                      Table *in_table,
+                      const unsigned char *old_record,
+                      const unsigned char *new_record);
 };
 
 } /* namespace drizzled */

=== modified file 'examples/client.c'
--- examples/client.c	2010-08-12 20:27:32 +0000
+++ examples/client.c	2010-09-28 07:50:05 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 #include "config.h"

=== modified file 'examples/pipe_query.c'
--- examples/pipe_query.c	2010-08-12 20:27:32 +0000
+++ examples/pipe_query.c	2010-09-28 07:50:05 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 #include "config.h"

=== modified file 'examples/proxy.c'
--- examples/proxy.c	2010-08-12 20:27:32 +0000
+++ examples/proxy.c	2010-09-28 07:50:05 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 #include <errno.h>

=== modified file 'examples/server.c'
--- examples/server.c	2010-08-12 20:27:32 +0000
+++ examples/server.c	2010-09-28 07:50:05 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 #include <errno.h>

=== modified file 'examples/simple.c'
--- examples/simple.c	2010-08-20 05:59:08 +0000
+++ examples/simple.c	2010-09-28 07:50:05 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 #include <stdio.h>

=== modified file 'examples/simple_multi.c'
--- examples/simple_multi.c	2010-08-12 20:27:32 +0000
+++ examples/simple_multi.c	2010-09-28 07:50:05 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 #include <stdio.h>

=== modified file 'examples/sqlite_server.c'
--- examples/sqlite_server.c	2010-08-12 20:27:32 +0000
+++ examples/sqlite_server.c	2010-09-28 07:50:05 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 #include <errno.h>

=== modified file 'extra/mysql_password_hash.c'
--- extra/mysql_password_hash.c	2010-08-12 20:27:32 +0000
+++ extra/mysql_password_hash.c	2010-09-28 07:50:05 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 #include "config.h"

=== modified file 'libdrizzle/column.c'
--- libdrizzle/column.c	2010-08-12 20:27:32 +0000
+++ libdrizzle/column.c	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/column.h'
--- libdrizzle/column.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/column.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/column_client.h'
--- libdrizzle/column_client.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/column_client.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/column_server.h'
--- libdrizzle/column_server.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/column_server.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/command.c'
--- libdrizzle/command.c	2010-08-12 20:27:32 +0000
+++ libdrizzle/command.c	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/command_client.h'
--- libdrizzle/command_client.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/command_client.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/command_server.h'
--- libdrizzle/command_server.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/command_server.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/common.h'
--- libdrizzle/common.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/common.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/conn.c'
--- libdrizzle/conn.c	2010-08-12 20:27:32 +0000
+++ libdrizzle/conn.c	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/conn.h'
--- libdrizzle/conn.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/conn.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/conn_client.h'
--- libdrizzle/conn_client.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/conn_client.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/conn_local.h'
--- libdrizzle/conn_local.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/conn_local.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/conn_server.h'
--- libdrizzle/conn_server.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/conn_server.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/conn_uds.c'
--- libdrizzle/conn_uds.c	2010-08-12 20:27:32 +0000
+++ libdrizzle/conn_uds.c	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/constants.h'
--- libdrizzle/constants.h	2010-08-13 05:39:56 +0000
+++ libdrizzle/constants.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/drizzle.c'
--- libdrizzle/drizzle.c	2010-08-12 20:27:32 +0000
+++ libdrizzle/drizzle.c	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/drizzle.h'
--- libdrizzle/drizzle.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/drizzle.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/drizzle_client.h'
--- libdrizzle/drizzle_client.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/drizzle_client.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/drizzle_local.h'
--- libdrizzle/drizzle_local.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/drizzle_local.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/drizzle_server.h'
--- libdrizzle/drizzle_server.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/drizzle_server.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/field.c'
--- libdrizzle/field.c	2010-08-12 20:27:32 +0000
+++ libdrizzle/field.c	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/field_client.h'
--- libdrizzle/field_client.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/field_client.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/field_server.h'
--- libdrizzle/field_server.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/field_server.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/handshake.c'
--- libdrizzle/handshake.c	2010-08-12 20:27:32 +0000
+++ libdrizzle/handshake.c	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/handshake_client.h'
--- libdrizzle/handshake_client.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/handshake_client.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/handshake_server.h'
--- libdrizzle/handshake_server.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/handshake_server.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/include.am'
--- libdrizzle/include.am	2010-09-27 06:11:48 +0000
+++ libdrizzle/include.am	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
 # All rights reserved.
 #
 # Use and distribution licensed under the BSD license.  See
-# the COPYING file in this directory for full text.
+# the COPYING.BSD file in the root source directory for full text.
 #
 #
 

=== modified file 'libdrizzle/pack.c'
--- libdrizzle/pack.c	2010-08-12 20:27:32 +0000
+++ libdrizzle/pack.c	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/pack.h'
--- libdrizzle/pack.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/pack.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/query.c'
--- libdrizzle/query.c	2010-08-12 20:27:32 +0000
+++ libdrizzle/query.c	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/query.h'
--- libdrizzle/query.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/query.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/result.c'
--- libdrizzle/result.c	2010-08-12 20:27:32 +0000
+++ libdrizzle/result.c	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/result.h'
--- libdrizzle/result.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/result.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/result_client.h'
--- libdrizzle/result_client.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/result_client.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/result_server.h'
--- libdrizzle/result_server.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/result_server.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/row.c'
--- libdrizzle/row.c	2010-08-13 00:11:19 +0000
+++ libdrizzle/row.c	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/row_client.h'
--- libdrizzle/row_client.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/row_client.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/row_server.h'
--- libdrizzle/row_server.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/row_server.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/state.c'
--- libdrizzle/state.c	2010-08-12 20:27:32 +0000
+++ libdrizzle/state.c	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/state.h'
--- libdrizzle/state.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/state.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/structs.h'
--- libdrizzle/structs.h	2010-08-20 17:54:51 +0000
+++ libdrizzle/structs.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'libdrizzle/visibility.h'
--- libdrizzle/visibility.h	2010-08-12 20:27:32 +0000
+++ libdrizzle/visibility.h	2010-09-28 07:47:48 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  * 
  * Implementation drawn from visibility.texi in gnulib.
  */

=== modified file 'm4/pandora_canonical.m4'
--- m4/pandora_canonical.m4	2010-09-19 22:38:19 +0000
+++ m4/pandora_canonical.m4	2010-09-29 03:14:51 +0000
@@ -234,9 +234,19 @@
   AC_CHECK_PROGS([PERL], [perl])
   AC_CHECK_PROGS([DPKG_GENSYMBOLS], [dpkg-gensymbols], [:])
   AC_CHECK_PROGS([SPHINXBUILD], [sphinx-build], [:])
+  AS_IF([test "x${SPHINXBUILD}" != "x:"],[
+    AC_CACHE_CHECK([if sphinx is new enough],[ac_cv_recent_sphinx],[
+    
+    ${SPHINXBUILD} -Q -C -b man -d conftest.d . . >/dev/null 2>&1
+    AS_IF([test $? -eq 0],[ac_cv_recent_sphinx=yes],
+          [ac_cv_recent_sphinx=no])
+    rm -rf conftest.d
+    ])
+  ])
 
   AM_CONDITIONAL(HAVE_DPKG_GENSYMBOLS,[test "x${DPKG_GENSYMBOLS}" != "x:"])
   AM_CONDITIONAL(HAVE_SPHINX,[test "x${SPHINXBUILD}" != "x:"])
+  AM_CONDITIONAL(HAVE_RECENT_SPHINX,[test "x${ac_cv_recent_sphinx}" = "xyes"])
 
   m4_if(m4_substr(m4_esyscmd(test -d po && echo 0),0,1),0, [
     AM_PO_SUBDIRS

=== removed file 'm4/pandora_have_libboost_regex.m4.moved'
--- m4/pandora_have_libboost_regex.m4.moved	2010-09-20 05:59:57 +0000
+++ m4/pandora_have_libboost_regex.m4.moved	1970-01-01 00:00:00 +0000
@@ -1,54 +0,0 @@
-dnl Copyright (C) 2010 Andrew Hutchings
-dnl This file is free software; Andrew Hutchings
-dnl gives unlimited permission to copy and/or distribute it,
-dnl with or without modifications, as long as this notice is preserved.
-
-AC_DEFUN([_PANDORA_SEARCH_BOOST_REGEX],[
-  AC_REQUIRE([AC_LIB_PREFIX])
-  AC_REQUIRE([ACX_PTHREAD])
-
-  dnl --------------------------------------------------------------------
-  dnl  Check for boost::regex
-  dnl --------------------------------------------------------------------
-
-  save_CFLAGS="${CFLAGS}"
-  save_CXXFLAGS="${CXXFLAGS}"
-  CFLAGS="${PTHREAD_CFLAGS} ${CFLAGS}"
-  CXXFLAGS="${PTHREAD_CFLAGS} ${CXXFLAGS}"
-
-  AC_LANG_PUSH(C++)
-  AC_LIB_HAVE_LINKFLAGS(boost_regex-mt,,[
-    #include <boost/regex.hpp>
-  ],[
-    boost::regex test_regex("drizzle");
-  ])
-  AS_IF([test "x${ac_cv_libboost_regex_mt}" = "xno"],[
-    AC_LIB_HAVE_LINKFLAGS(boost_regex,,[
-      #include <boost/regex.hpp>
-    ],[
-      boost::regex test_regex("drizzle");
-    ])
-  ])
-  AC_LANG_POP()
-  CFLAGS="${save_CFLAGS}"
-  CXXFLAGS="${save_CXXFLAGS}"
-
-  
-  AM_CONDITIONAL(HAVE_BOOST_REGEX,
-    [test "x${ac_cv_libboost_regex}" = "xyes" -o "x${ac_cv_libboost_regex_mt}" = "xyes"])
-  BOOST_LIBS="${BOOST_LIBS} ${LTLIBBOOST_REGEX_MT} ${LTLIBBOOST_REGEX}"
-  AC_SUBST(BOOST_LIBS) 
-])
-
-AC_DEFUN([PANDORA_HAVE_BOOST_REGEX],[
-  PANDORA_HAVE_BOOST($1)
-  _PANDORA_SEARCH_BOOST_REGEX($1)
-])
-
-AC_DEFUN([PANDORA_REQUIRE_BOOST_REGEX],[
-  PANDORA_REQUIRE_BOOST($1)
-  _PANDORA_SEARCH_BOOST_REGEX($1)
-  AS_IF([test "x${ac_cv_libboost_regex}" = "xno" -a "x${ac_cv_libboost_regex_mt}" = "xno"],
-      AC_MSG_ERROR([boost::regex is required for ${PACKAGE}]))
-])
-

=== modified file 'plugin/auth_ldap/schema/gentestusers.sh'
--- plugin/auth_ldap/schema/gentestusers.sh	2010-05-05 20:49:48 +0000
+++ plugin/auth_ldap/schema/gentestusers.sh	2010-09-28 07:43:29 +0000
@@ -1,4 +1,5 @@
 #!/bin/bash
+# Copyright (c) 2010 Edward "Koko" Konetzko <konetzed@quixoticagony.com>
 
 help() {
     echo "Arguement options are:"

=== modified file 'plugin/auth_ldap/schema/openldap/drizzle.ldif'
--- plugin/auth_ldap/schema/openldap/drizzle.ldif	2010-05-05 20:49:48 +0000
+++ plugin/auth_ldap/schema/openldap/drizzle.ldif	2010-09-28 07:43:29 +0000
@@ -1,3 +1,4 @@
+# Copyright (c) 2010 Edward "Koko" Konetzko <konetzed@quixoticagony.com>
 dn: cn=drizzle,cn=schema,cn=config
 objectClass: olcSchemaConfig
 cn: drizzle

=== modified file 'plugin/auth_ldap/schema/openldap/drizzle.schema'
--- plugin/auth_ldap/schema/openldap/drizzle.schema	2010-05-05 20:49:48 +0000
+++ plugin/auth_ldap/schema/openldap/drizzle.schema	2010-09-28 07:43:29 +0000
@@ -1,3 +1,4 @@
+# Copyright (c) 2010 Edward "Koko" Konetzko <konetzed@quixoticagony.com>
 attributetype ( 1.3.6.1.4.1.35583.1.1
     NAME 'drizzleUserMysqlPassword'
         DESC 'Attribute for mysql > 4.1 hash'

=== modified file 'plugin/auth_ldap/test_ldap.sh'
--- plugin/auth_ldap/test_ldap.sh	2010-06-23 20:51:16 +0000
+++ plugin/auth_ldap/test_ldap.sh	2010-09-28 07:43:29 +0000
@@ -1,4 +1,5 @@
 #!/bin/sh
+# Copyright (C) 2010 Eric Day
 
 # Kill any leftover processes from before
 pids=`ps -ef|grep drizzled|grep 12345|awk '{print $2}'`

=== modified file 'plugin/embedded_innodb/embedded_innodb_engine.cc'
--- plugin/embedded_innodb/embedded_innodb_engine.cc	2010-09-27 16:15:40 +0000
+++ plugin/embedded_innodb/embedded_innodb_engine.cc	2010-09-28 21:16:58 +0000
@@ -642,35 +642,102 @@
                       statement_savepoint_name.length());
   }
 
-  /* the below is just copied from ha_archive.cc in some dim hope it's
-     kinda right. */
-
-  if (lock_type != TL_IGNORE && lock.type == TL_UNLOCK)
-  {
-    /*
-      Here is where we get into the guts of a row level lock.
-      If TL_UNLOCK is set
-      If we are not doing a LOCK Table or DISCARD/IMPORT
-      TABLESPACE, then allow multiple writers
+  /* the below is adapted from ha_innodb.cc */
+
+  const uint32_t sql_command = session_sql_command(session);
+
+  if (sql_command == SQLCOM_DROP_TABLE) {
+
+    /* MySQL calls this function in DROP Table though this table
+    handle may belong to another session that is running a query.
+    Let us in that case skip any changes to the prebuilt struct. */ 
+
+  } else if (lock_type == TL_READ_WITH_SHARED_LOCKS
+       || lock_type == TL_READ_NO_INSERT
+       || (lock_type != TL_IGNORE
+           && sql_command != SQLCOM_SELECT)) {
+
+    /* The OR cases above are in this order:
+    1) MySQL is doing LOCK TABLES ... READ LOCAL, or we
+    are processing a stored procedure or function, or
+    2) (we do not know when TL_READ_HIGH_PRIORITY is used), or
+    3) this is a SELECT ... IN SHARE MODE, or
+    4) we are doing a complex SQL statement like
+    INSERT INTO ... SELECT ... and the logical logging (MySQL
+    binlog) requires the use of a locking read, or
+    MySQL is doing LOCK TABLES ... READ.
+    5) we let InnoDB do locking reads for all SQL statements that
+    are not simple SELECTs; note that select_lock_type in this
+    case may get strengthened in ::external_lock() to LOCK_X.
+    Note that we MUST use a locking read in all data modifying
+    SQL statements, because otherwise the execution would not be
+    serializable, and also the results from the update could be
+    unexpected if an obsolete consistent read view would be
+    used. */
+
+    enum_tx_isolation isolation_level= session_tx_isolation(session);
+
+    if (isolation_level != ISO_SERIALIZABLE
+        && (lock_type == TL_READ || lock_type == TL_READ_NO_INSERT)
+        && (sql_command == SQLCOM_INSERT_SELECT
+      || sql_command == SQLCOM_UPDATE
+      || sql_command == SQLCOM_CREATE_TABLE)) {
+
+      /* If we either have innobase_locks_unsafe_for_binlog
+      option set or this session is using READ COMMITTED
+      isolation level and isolation level of the transaction
+      is not set to serializable and MySQL is doing
+      INSERT INTO...SELECT or UPDATE ... = (SELECT ...) or
+      CREATE  ... SELECT... without FOR UPDATE or
+      IN SHARE MODE in select, then we use consistent
+      read for select. */
+
+      ib_lock_mode= IB_LOCK_NONE;
+    } else if (sql_command == SQLCOM_CHECKSUM) {
+      /* Use consistent read for checksum table */
+
+      ib_lock_mode= IB_LOCK_NONE;
+    } else {
+      ib_lock_mode= IB_LOCK_S;
+    }
+
+  } else if (lock_type != TL_IGNORE) {
+
+    /* We set possible LOCK_X value in external_lock, not yet
+    here even if this would be SELECT ... FOR UPDATE */
+    ib_lock_mode= IB_LOCK_NONE;
+  }
+
+  if (lock_type != TL_IGNORE && lock.type == TL_UNLOCK) {
+
+    /* If we are not doing a LOCK TABLE, DISCARD/IMPORT
+    TABLESPACE or TRUNCATE TABLE then allow multiple
+    writers. Note that ALTER TABLE uses a TL_WRITE_ALLOW_READ
+    < TL_WRITE_CONCURRENT_INSERT.
     */
 
-    if ((lock_type >= TL_WRITE_CONCURRENT_INSERT &&
-         lock_type <= TL_WRITE)
-        && !session_tablespace_op(session))
+    if ((lock_type >= TL_WRITE_CONCURRENT_INSERT
+         && lock_type <= TL_WRITE)
+        && !session_tablespace_op(session)
+        && sql_command != SQLCOM_TRUNCATE
+        && sql_command != SQLCOM_CREATE_TABLE) {
+
       lock_type = TL_WRITE_ALLOW_WRITE;
+    }
 
-    /*
-      In queries of type INSERT INTO t1 SELECT ... FROM t2 ...
-      MySQL would use the lock TL_READ_NO_INSERT on t2, and that
-      would conflict with TL_WRITE_ALLOW_WRITE, blocking all inserts
-      to t2. Convert the lock to a normal read lock to allow
-      concurrent inserts to t2.
+    /* In queries of type INSERT INTO t1 SELECT ... FROM t2 ...
+    MySQL would use the lock TL_READ_NO_INSERT on t2, and that
+    would conflict with TL_WRITE_ALLOW_WRITE, blocking all inserts
+    to t2. Convert the lock to a normal read lock to allow
+    concurrent inserts to t2.
     */
 
-    if (lock_type == TL_READ_NO_INSERT)
+    if (lock_type == TL_READ_NO_INSERT) {
+
       lock_type = TL_READ;
+    }
 
-    lock.type=lock_type;
+    lock.type = lock_type;
   }
 
   *to++= &lock;

=== added file 'plugin/embedded_innodb/test-suite-dir/embedded_innodb/tests/r/lock_in_shared_mode.result'
--- plugin/embedded_innodb/test-suite-dir/embedded_innodb/tests/r/lock_in_shared_mode.result	1970-01-01 00:00:00 +0000
+++ plugin/embedded_innodb/test-suite-dir/embedded_innodb/tests/r/lock_in_shared_mode.result	2010-09-28 12:16:41 +0000
@@ -0,0 +1,19 @@
+create table t1(a int not null, b int, primary key(a)) engine=innodb;
+insert into t1 values(1,1),(2,2),(3,1),(4,2),(5,1),(6,2);
+commit;
+set autocommit = 0;
+select * from t1 lock in share mode;
+a	b
+1	1
+2	2
+3	1
+4	2
+5	1
+6	2
+update t1 set b = 5 where b = 1;
+set autocommit = 0;
+select * from t1 where a = 2 and b = 2 for update;
+ERROR HY000: Lock wait timeout exceeded; try restarting transaction
+commit;
+commit;
+drop table t1;

=== added file 'plugin/embedded_innodb/test-suite-dir/embedded_innodb/tests/t/lock_in_shared_mode.test'
--- plugin/embedded_innodb/test-suite-dir/embedded_innodb/tests/t/lock_in_shared_mode.test	1970-01-01 00:00:00 +0000
+++ plugin/embedded_innodb/test-suite-dir/embedded_innodb/tests/t/lock_in_shared_mode.test	2010-09-28 12:16:41 +0000
@@ -0,0 +1,34 @@
+#
+# Test case where no locks should be released (because we are not
+# using READ COMMITTED isolation level)
+#
+
+connect (a,localhost,root,,);
+connect (b,localhost,root,,);
+connection a;
+create table t1(a int not null, b int, primary key(a)) engine=innodb;
+insert into t1 values(1,1),(2,2),(3,1),(4,2),(5,1),(6,2);
+commit;
+set autocommit = 0;
+select * from t1 lock in share mode;
+update t1 set b = 5 where b = 1;
+connection b;
+set autocommit = 0;
+#
+# S-lock to records (2,2),(4,2), and (6,2) should not be released in a update
+#
+--error ER_LOCK_WAIT_TIMEOUT
+select * from t1 where a = 2 and b = 2 for update;
+#
+# X-lock to record (1,1),(3,1),(5,1) should not be released in a update
+#
+--error ER_LOCK_WAIT_TIMEOUT
+connection a;
+commit;
+connection b;
+commit;
+connection default;
+disconnect a;
+disconnect b;
+drop table t1;
+

=== modified file 'plugin/mysql_protocol/prototest/drizzle_flood'
--- plugin/mysql_protocol/prototest/drizzle_flood	2010-03-17 02:01:05 +0000
+++ plugin/mysql_protocol/prototest/drizzle_flood	2010-09-28 07:50:05 +0000
@@ -6,7 +6,7 @@
 # All rights reserved.
 # 
 # Use and distribution licensed under the BSD license.  See
-# the COPYING file in this directory for full text.
+# the COPYING.BSD file in the root source directory for full text.
 #
 '''
 Send an infinite amount of data to a MySQL server.

=== modified file 'plugin/mysql_protocol/prototest/drizzle_prototest'
--- plugin/mysql_protocol/prototest/drizzle_prototest	2010-06-20 14:27:46 +0000
+++ plugin/mysql_protocol/prototest/drizzle_prototest	2010-09-28 07:50:05 +0000
@@ -6,7 +6,7 @@
 # All rights reserved.
 # 
 # Use and distribution licensed under the BSD license.  See
-# the COPYING file in this directory for full text.
+# the COPYING.BSD file in the root source directory for full text.
 #
 '''
 Drizzle and MySQL Protocol Test Suite

=== modified file 'plugin/mysql_protocol/prototest/prototest/mysql/bitfield.py'
--- plugin/mysql_protocol/prototest/prototest/mysql/bitfield.py	2010-03-10 23:31:17 +0000
+++ plugin/mysql_protocol/prototest/prototest/mysql/bitfield.py	2010-09-28 07:50:05 +0000
@@ -6,7 +6,7 @@
 # All rights reserved.
 # 
 # Use and distribution licensed under the BSD license.  See
-# the COPYING file in this directory for full text.
+# the COPYING.BSD file in the root source directory for full text.
 #
 
 import unittest

=== modified file 'plugin/mysql_protocol/prototest/prototest/mysql/column.py'
--- plugin/mysql_protocol/prototest/prototest/mysql/column.py	2010-03-10 23:31:17 +0000
+++ plugin/mysql_protocol/prototest/prototest/mysql/column.py	2010-09-28 07:50:05 +0000
@@ -6,7 +6,7 @@
 # All rights reserved.
 # 
 # Use and distribution licensed under the BSD license.  See
-# the COPYING file in this directory for full text.
+# the COPYING.BSD file in the root source directory for full text.
 #
 '''
 MySQL Protocol Column Objects

=== modified file 'plugin/mysql_protocol/prototest/prototest/mysql/command.py'
--- plugin/mysql_protocol/prototest/prototest/mysql/command.py	2010-03-10 23:31:17 +0000
+++ plugin/mysql_protocol/prototest/prototest/mysql/command.py	2010-09-28 07:50:05 +0000
@@ -6,7 +6,7 @@
 # All rights reserved.
 # 
 # Use and distribution licensed under the BSD license.  See
-# the COPYING file in this directory for full text.
+# the COPYING.BSD file in the root source directory for full text.
 #
 '''
 MySQL Protocol Command Objects

=== modified file 'plugin/mysql_protocol/prototest/prototest/mysql/handshake.py'
--- plugin/mysql_protocol/prototest/prototest/mysql/handshake.py	2010-03-10 23:31:17 +0000
+++ plugin/mysql_protocol/prototest/prototest/mysql/handshake.py	2010-09-28 07:50:05 +0000
@@ -6,7 +6,7 @@
 # All rights reserved.
 # 
 # Use and distribution licensed under the BSD license.  See
-# the COPYING file in this directory for full text.
+# the COPYING.BSD file in the root source directory for full text.
 #
 '''
 MySQL Protocol Handshake Objects

=== modified file 'plugin/mysql_protocol/prototest/prototest/mysql/packet.py'
--- plugin/mysql_protocol/prototest/prototest/mysql/packet.py	2010-03-15 22:34:38 +0000
+++ plugin/mysql_protocol/prototest/prototest/mysql/packet.py	2010-09-28 07:50:05 +0000
@@ -6,7 +6,7 @@
 # All rights reserved.
 # 
 # Use and distribution licensed under the BSD license.  See
-# the COPYING file in this directory for full text.
+# the COPYING.BSD file in the root source directory for full text.
 #
 '''
 MySQL Protocol Packet Objects

=== modified file 'plugin/mysql_protocol/prototest/prototest/mysql/result.py'
--- plugin/mysql_protocol/prototest/prototest/mysql/result.py	2010-03-10 23:31:17 +0000
+++ plugin/mysql_protocol/prototest/prototest/mysql/result.py	2010-09-28 07:50:05 +0000
@@ -6,7 +6,7 @@
 # All rights reserved.
 # 
 # Use and distribution licensed under the BSD license.  See
-# the COPYING file in this directory for full text.
+# the COPYING.BSD file in the root source directory for full text.
 #
 '''
 MySQL Protocol Result Objects

=== modified file 'plugin/signal_handler/signal_handler.cc'
--- plugin/signal_handler/signal_handler.cc	2010-09-21 16:34:24 +0000
+++ plugin/signal_handler/signal_handler.cc	2010-09-27 23:26:59 +0000
@@ -102,7 +102,8 @@
     }
     (void)close(file); /* We can ignore the error, since we are going to error anyway at this point */
   }
-  snprintf(buff, 1024, "Can't start server: can't create PID file (%s)", pidfile_name);
+  memset(buff, 0, sizeof(buff));
+  snprintf(buff, sizeof(buff)-1, "Can't start server: can't create PID file (%s)", pidfile_name);
   sql_perror(buff);
   exit(1);
 }

=== modified file 'plugin/transaction_log/tests/r/null_values.result'
--- plugin/transaction_log/tests/r/null_values.result	2010-09-19 23:53:02 +0000
+++ plugin/transaction_log/tests/r/null_values.result	2010-09-28 01:41:30 +0000
@@ -1,4 +1,4 @@
-DROP TABLE IF EXISTS t1, t2, t3;
+DROP TABLE IF EXISTS t1, t2, t3, t4;
 CREATE TABLE t1 (a INT NOT NULL, b CHAR(1000), PRIMARY KEY (a));
 INSERT INTO t1 VALUES (1,"update me");
 INSERT INTO t1 VALUES (2,'');
@@ -13,7 +13,11 @@
 CREATE TABLE t3 (a INT NOT NULL, b ENUM ('1','2'), PRIMARY KEY(a));
 INSERT INTO t3 VALUES (1,'1');
 INSERT INTO t3 VALUES (2,NULL);
-DROP TABLE t1, t2, t3;
+CREATE TABLE t4 (id INT NOT NULL, col0_int INT DEFAULT NULL, col1_int INT DEFAULT NULL, PRIMARY KEY (id));
+INSERT INTO t4 VALUES (1, NULL, 1);
+UPDATE t4 SET col0_int= 0 WHERE col1_int != 2;
+UPDATE t4 SET col0_int= NULL WHERE col1_int != 2;
+DROP TABLE t1, t2, t3, t4;
 START TRANSACTION;
 DROP TABLE IF EXISTS `test`.`t1`;
 COMMIT;
@@ -24,6 +28,9 @@
 DROP TABLE IF EXISTS `test`.`t3`;
 COMMIT;
 START TRANSACTION;
+DROP TABLE IF EXISTS `test`.`t4`;
+COMMIT;
+START TRANSACTION;
 CREATE TABLE `test`.`t1` (   `a` INT NOT NULL,   `b` VARCHAR(1000) COLLATE utf8_general_ci DEFAULT NULL,   PRIMARY KEY (`a`) ) ENGINE=InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
@@ -67,6 +74,18 @@
 INSERT INTO `test`.`t3` (`a`,`b`) VALUES (2,NULL);
 COMMIT;
 START TRANSACTION;
+CREATE TABLE `test`.`t4` (   `id` INT NOT NULL,   `col0_int` INT DEFAULT NULL,   `col1_int` INT DEFAULT NULL,   PRIMARY KEY (`id`) ) ENGINE=InnoDB COLLATE = utf8_general_ci;
+COMMIT;
+START TRANSACTION;
+INSERT INTO `test`.`t4` (`id`,`col0_int`,`col1_int`) VALUES (1,NULL,1);
+COMMIT;
+START TRANSACTION;
+UPDATE `test`.`t4` SET `col0_int`=0 WHERE `id`=1;
+COMMIT;
+START TRANSACTION;
+UPDATE `test`.`t4` SET `col0_int`=NULL WHERE `id`=1;
+COMMIT;
+START TRANSACTION;
 DROP TABLE `test`.`t1`;
 COMMIT;
 START TRANSACTION;
@@ -75,4 +94,7 @@
 START TRANSACTION;
 DROP TABLE `test`.`t3`;
 COMMIT;
+START TRANSACTION;
+DROP TABLE `test`.`t4`;
+COMMIT;
 SET GLOBAL transaction_log_truncate_debug= true;

=== modified file 'plugin/transaction_log/tests/r/transaction_log_update.result'
--- plugin/transaction_log/tests/r/transaction_log_update.result	2010-09-17 14:56:24 +0000
+++ plugin/transaction_log/tests/r/transaction_log_update.result	2010-09-28 01:41:30 +0000
@@ -1352,3 +1352,139 @@
 DROP TABLE t1;
 SET GLOBAL transaction_log_truncate_debug= true;
 
+Testing UPDATE LP Bug#644529
+DROP TABLE IF EXISTS t1;
+CREATE TABLE t1 (
+id INT NOT NULL
+, col0_int INT DEFAULT NULL
+, col1_int INT DEFAULT NULL
+, PRIMARY KEY (id)
+);
+INSERT INTO t1 VALUES (1, NULL, 1);
+UPDATE t1 SET col0_int= 0 WHERE col1_int != 2;
+# check transaction_log
+SELECT * FROM DATA_DICTIONARY.TRANSACTION_LOG;
+FILE_NAME	FILE_LENGTH	NUM_LOG_ENTRIES	NUM_TRANSACTIONS	MIN_TRANSACTION_ID	MAX_TRANSACTION_ID	MIN_END_TIMESTAMP	MAX_END_TIMESTAMP	INDEX_SIZE_IN_BYTES
+transaction.log	512	4	4	1	4	START_TIMESTAMP	END_TIMESTAMP	INDEX_SIZE
+
+Check transaction_log_entries
+SELECT * FROM DATA_DICTIONARY.TRANSACTION_LOG_ENTRIES;
+ENTRY_OFFSET	ENTRY_TYPE	ENTRY_LENGTH
+0	TRANSACTION	75
+75	TRANSACTION	197
+272	TRANSACTION	130
+402	TRANSACTION	110
+
+Check transaction_log_transactions
+SELECT * FROM DATA_DICTIONARY.TRANSACTION_LOG_TRANSACTIONS;
+ENTRY_OFFSET	TRANSACTION_ID	SERVER_ID	START_TIMESTAMP	END_TIMESTAMP	NUM_STATEMENTS	CHECKSUM
+0	1	1	START_TIMESTAMP	END_TIMESTAMP	1	0
+75	2	1	START_TIMESTAMP	END_TIMESTAMP	1	0
+272	3	1	START_TIMESTAMP	END_TIMESTAMP	1	0
+402	4	1	START_TIMESTAMP	END_TIMESTAMP	1	0
+Check transaction log contents
+SELECT PRINT_TRANSACTION_MESSAGE('transaction.log',(select max(entry_offset) from DATA_DICTIONARY.TRANSACTION_LOG_TRANSACTIONS));
+PRINT_TRANSACTION_MESSAGE('transaction.log',(select max(entry_offset) from DATA_DICTIONARY.TRANSACTION_LOG_TRANSACTIONS))
+transaction_context {
+  server_id: 1
+  transaction_id: 4
+  START_TIMESTAMP
+  END_TIMESTAMP
+}
+statement {
+  type: UPDATE
+  START_TIMESTAMP
+  END_TIMESTAMP
+  update_header {
+    table_metadata {
+      schema_name: "test"
+      table_name: "t1"
+    }
+    key_field_metadata {
+      type: INTEGER
+      name: "id"
+    }
+    set_field_metadata {
+      type: INTEGER
+      name: "col0_int"
+    }
+  }
+  update_data {
+    segment_id: 1
+    end_segment: true
+    record {
+      key_value: "1"
+      after_value: "0"
+      is_null: false
+    }
+  }
+}
+
+
+
+UPDATE t1 SET col0_int= NULL WHERE col1_int != 2;
+# check transaction_log
+SELECT * FROM DATA_DICTIONARY.TRANSACTION_LOG;
+FILE_NAME	FILE_LENGTH	NUM_LOG_ENTRIES	NUM_TRANSACTIONS	MIN_TRANSACTION_ID	MAX_TRANSACTION_ID	MIN_END_TIMESTAMP	MAX_END_TIMESTAMP	INDEX_SIZE_IN_BYTES
+transaction.log	621	5	5	1	5	START_TIMESTAMP	END_TIMESTAMP	INDEX_SIZE
+
+Check transaction_log_entries
+SELECT * FROM DATA_DICTIONARY.TRANSACTION_LOG_ENTRIES;
+ENTRY_OFFSET	ENTRY_TYPE	ENTRY_LENGTH
+0	TRANSACTION	75
+75	TRANSACTION	197
+272	TRANSACTION	130
+402	TRANSACTION	110
+512	TRANSACTION	109
+
+Check transaction_log_transactions
+SELECT * FROM DATA_DICTIONARY.TRANSACTION_LOG_TRANSACTIONS;
+ENTRY_OFFSET	TRANSACTION_ID	SERVER_ID	START_TIMESTAMP	END_TIMESTAMP	NUM_STATEMENTS	CHECKSUM
+0	1	1	START_TIMESTAMP	END_TIMESTAMP	1	0
+75	2	1	START_TIMESTAMP	END_TIMESTAMP	1	0
+272	3	1	START_TIMESTAMP	END_TIMESTAMP	1	0
+402	4	1	START_TIMESTAMP	END_TIMESTAMP	1	0
+512	5	1	START_TIMESTAMP	END_TIMESTAMP	1	0
+Check transaction log contents
+SELECT PRINT_TRANSACTION_MESSAGE('transaction.log',(select max(entry_offset) from DATA_DICTIONARY.TRANSACTION_LOG_TRANSACTIONS));
+PRINT_TRANSACTION_MESSAGE('transaction.log',(select max(entry_offset) from DATA_DICTIONARY.TRANSACTION_LOG_TRANSACTIONS))
+transaction_context {
+  server_id: 1
+  transaction_id: 5
+  START_TIMESTAMP
+  END_TIMESTAMP
+}
+statement {
+  type: UPDATE
+  START_TIMESTAMP
+  END_TIMESTAMP
+  update_header {
+    table_metadata {
+      schema_name: "test"
+      table_name: "t1"
+    }
+    key_field_metadata {
+      type: INTEGER
+      name: "id"
+    }
+    set_field_metadata {
+      type: INTEGER
+      name: "col0_int"
+    }
+  }
+  update_data {
+    segment_id: 1
+    end_segment: true
+    record {
+      key_value: "1"
+      after_value: ""
+      is_null: true
+    }
+  }
+}
+
+
+
+DROP TABLE t1;
+SET GLOBAL transaction_log_truncate_debug= true;
+

=== modified file 'plugin/transaction_log/tests/t/null_values.inc'
--- plugin/transaction_log/tests/t/null_values.inc	2010-09-19 23:53:02 +0000
+++ plugin/transaction_log/tests/t/null_values.inc	2010-09-28 01:41:30 +0000
@@ -3,7 +3,7 @@
 #
 
 --disable_warnings
-DROP TABLE IF EXISTS t1, t2, t3;
+DROP TABLE IF EXISTS t1, t2, t3, t4;
 --enable_warnings
 
 CREATE TABLE t1 (a INT NOT NULL, b CHAR(1000), PRIMARY KEY (a));
@@ -26,4 +26,9 @@
 INSERT INTO t3 VALUES (1,'1');
 INSERT INTO t3 VALUES (2,NULL);
 
-DROP TABLE t1, t2, t3;
+CREATE TABLE t4 (id INT NOT NULL, col0_int INT DEFAULT NULL, col1_int INT DEFAULT NULL, PRIMARY KEY (id));
+INSERT INTO t4 VALUES (1, NULL, 1);
+UPDATE t4 SET col0_int= 0 WHERE col1_int != 2;
+UPDATE t4 SET col0_int= NULL WHERE col1_int != 2;
+
+DROP TABLE t1, t2, t3, t4;

=== modified file 'plugin/transaction_log/tests/t/transaction_log_update.test'
--- plugin/transaction_log/tests/t/transaction_log_update.test	2010-09-08 23:36:36 +0000
+++ plugin/transaction_log/tests/t/transaction_log_update.test	2010-09-28 01:41:30 +0000
@@ -309,3 +309,29 @@
 --source ../plugin/transaction_log/tests/t/truncate_log.inc
 --echo
 
+--echo Testing UPDATE LP Bug#644529
+--disable_warnings
+DROP TABLE IF EXISTS t1;
+--enable_warnings
+
+CREATE TABLE t1 (
+  id INT NOT NULL
+, col0_int INT DEFAULT NULL
+, col1_int INT DEFAULT NULL
+, PRIMARY KEY (id)
+);
+
+INSERT INTO t1 VALUES (1, NULL, 1);
+UPDATE t1 SET col0_int= 0 WHERE col1_int != 2;
+--source ../plugin/transaction_log/tests/t/check_transaction_log.inc
+--echo
+UPDATE t1 SET col0_int= NULL WHERE col1_int != 2;    
+--source ../plugin/transaction_log/tests/t/check_transaction_log.inc
+--echo
+
+DROP TABLE t1;
+
+# Truncate the log file to reset for the next test
+--source ../plugin/transaction_log/tests/t/truncate_log.inc
+--echo
+

=== modified file 'tests/include.am'
--- tests/include.am	2010-08-18 16:12:58 +0000
+++ tests/include.am	2010-09-28 16:06:16 +0000
@@ -22,7 +22,8 @@
 GENSCRIPTS =		tests/dtr tests/mtr tests/test-run
 PRESCRIPTS =		tests/test-run.pl tests/stress-test.pl
 PLUGIN_TESTS =		$(pandora_plugin_test_list)
-ALL_TESTS =		main,big,$(PLUGIN_TESTS)
+NORMAL_TESTS =		main,jp,tamil,$(PLUGIN_TESTS)
+ALL_TESTS =		main,big,jp,tamil,$(PLUGIN_TESTS)
 noinst_SCRIPTS =	$(GENSCRIPTS) $(PRESCRIPTS)
 CLEANFILES += 		$(GENSCRIPTS) tests/mtr
 
@@ -93,16 +94,16 @@
 	( cd tests && $(TEST_RUN) $(TEST_RUN_EXTRA_OPTIONS) --fast --force --suite=$(ALL_TESTS))
 
 test-drizzle:
-	( cd tests && $(TEST_RUN) $(TEST_RUN_EXTRA_OPTIONS) --fast --force --suite=main,$(PLUGIN_TESTS))
+	( cd tests && $(TEST_RUN) $(TEST_RUN_EXTRA_OPTIONS) --fast --force --suite=$(NORMAL_TESTS))
 
 test-valgrind:
-	( cd tests && $(TEST_RUN) $(TEST_RUN_EXTRA_OPTIONS) --valgrind --force --suite=main,$(PLUGIN_TESTS))
+	( cd tests && $(TEST_RUN) $(TEST_RUN_EXTRA_OPTIONS) --valgrind --force --suite=$(NORMAL_TESTS))
 
 test-valgrind-suppressions:
-	( cd tests && $(TEST_RUN) $(TEST_RUN_EXTRA_OPTIONS) --valgrind --valgrind-option='--gen-suppressions=all' --valgrind-option='--show-reachable=yes' --force --suite=main,$(PLUGIN_TESTS))
+	( cd tests && $(TEST_RUN) $(TEST_RUN_EXTRA_OPTIONS) --valgrind --valgrind-option='--gen-suppressions=all' --valgrind-option='--show-reachable=yes' --force --suite=$(NORMAL_TESTS))
 
 test-junitxml:
-	( cd tests && $(TEST_RUN) $(TEST_RUN_EXTRA_OPTIONS) --fast --force --suite=main,$(PLUGIN_TESTS) --subunit | subunit2junitxml --no-passthrough > junit-format.xml )
+	( cd tests && $(TEST_RUN) $(TEST_RUN_EXTRA_OPTIONS) --fast --force --suite=$(NORMAL_TESTS) --subunit | subunit2junitxml --no-passthrough > junit-format.xml )
 
 test-big:
 	( cd tests && $(TEST_RUN) $(TEST_RUN_EXTRA_OPTIONS) --fast --force --suite=big )

=== modified file 'tests/suite/jp/r/jp_like_utf8.result'
--- tests/suite/jp/r/jp_like_utf8.result	2010-06-22 19:48:34 +0000
+++ tests/suite/jp/r/jp_like_utf8.result	2010-09-28 16:06:16 +0000
@@ -16,18 +16,18 @@
 CREATE TEMPORARY TABLE `Ｔ７` (`Ｃ１` char(20), INDEX(`Ｃ１`))  engine = MEMORY;
 CREATE TEMPORARY TABLE `Ｔ８` (`Ｃ１` char(20), INDEX(`Ｃ１`))  engine = MEMORY;
 CREATE TEMPORARY TABLE `Ｔ９` (`Ｃ１` char(20), INDEX(`Ｃ１`))  engine = MEMORY;
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ１`;
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ２`;
-ERROR 22001: Data too long for column 'Ｃ１' at row 30
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ３`;
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ４`;
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ５`;
-ERROR 22001: Data too long for column 'Ｃ１' at row 30
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ６`;
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ７`;
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ８`;
-ERROR 22001: Data too long for column 'Ｃ１' at row 30
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ９`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ１`;
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ２`;
+ERROR 22001: Data too long for column 'Ｃ１' at row 30
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ３`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ４`;
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ５`;
+ERROR 22001: Data too long for column 'Ｃ１' at row 30
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ６`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ７`;
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ８`;
+ERROR 22001: Data too long for column 'Ｃ１' at row 30
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ９`;
 SELECT * FROM `Ｔ１` WHERE `Ｃ１` LIKE ' %';
 Ｃ１
  !"#$%&'()*+,-./

=== modified file 'tests/suite/jp/r/jp_select_utf8.result'
--- tests/suite/jp/r/jp_select_utf8.result	2010-06-22 19:48:34 +0000
+++ tests/suite/jp/r/jp_select_utf8.result	2010-09-28 16:06:16 +0000
@@ -16,18 +16,18 @@
 CREATE TEMPORARY TABLE `Ｔ７` (c1 char(20), INDEX(c1))  engine = MEMORY;
 CREATE TEMPORARY TABLE `Ｔ８` (c1 char(20), INDEX(c1))  engine = MEMORY;
 CREATE TEMPORARY TABLE `Ｔ９` (c1 char(20), INDEX(c1))  engine = MEMORY;
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ１`;
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ２`;
-ERROR 22001: Data too long for column 'c1' at row 30
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ３`;
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ４`;
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ５`;
-ERROR 22001: Data too long for column 'c1' at row 30
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ６`;
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ７`;
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ８`;
-ERROR 22001: Data too long for column 'c1' at row 30
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ９`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ１`;
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ２`;
+ERROR 22001: Data too long for column 'c1' at row 30
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ３`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ４`;
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ５`;
+ERROR 22001: Data too long for column 'c1' at row 30
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ６`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ７`;
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ８`;
+ERROR 22001: Data too long for column 'c1' at row 30
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ９`;
 SELECT * FROM `Ｔ１`;
 c1
  !"#$%&'()*+,-./

=== modified file 'tests/suite/jp/r/jp_where_utf8.result'
--- tests/suite/jp/r/jp_where_utf8.result	2010-06-22 19:48:34 +0000
+++ tests/suite/jp/r/jp_where_utf8.result	2010-09-28 16:06:16 +0000
@@ -16,18 +16,18 @@
 CREATE TEMPORARY TABLE `Ｔ７` (`Ｃ１` char(20), INDEX(`Ｃ１`))  engine = MEMORY;
 CREATE TEMPORARY TABLE `Ｔ８` (`Ｃ１` char(20), INDEX(`Ｃ１`))  engine = MEMORY;
 CREATE TEMPORARY TABLE `Ｔ９` (`Ｃ１` char(20), INDEX(`Ｃ１`))  engine = MEMORY;
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ１`;
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ２`;
-ERROR 22001: Data too long for column 'Ｃ１' at row 30
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ３`;
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ４`;
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ５`;
-ERROR 22001: Data too long for column 'Ｃ１' at row 30
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ６`;
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ７`;
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ８`;
-ERROR 22001: Data too long for column 'Ｃ１' at row 30
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ９`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ１`;
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ２`;
+ERROR 22001: Data too long for column 'Ｃ１' at row 30
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ３`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ４`;
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ５`;
+ERROR 22001: Data too long for column 'Ｃ１' at row 30
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ６`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ７`;
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ８`;
+ERROR 22001: Data too long for column 'Ｃ１' at row 30
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ９`;
 SELECT * FROM `Ｔ１` WHERE `Ｃ１` = 'ｰｱｲｳｴｵｶｷｸｹｺｻｼｽｾｿ';
 Ｃ１
 ｰｱｲｳｴｵｶｷｸｹｺｻｼｽｾｿ

=== modified file 'tests/suite/jp/t/jp_like_utf8.test'
--- tests/suite/jp/t/jp_like_utf8.test	2010-08-26 21:56:15 +0000
+++ tests/suite/jp/t/jp_like_utf8.test	2010-09-28 16:06:16 +0000
@@ -29,18 +29,18 @@
 # jisx0208 data
 # jisx0212 supplemental character data
 
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ１`;
---error ER_DATA_TOO_LONG
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ２`;
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ３`;
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ４`;
---error ER_DATA_TOO_LONG
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ５`;
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ６`;
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ７`;
---error ER_DATA_TOO_LONG
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ８`;
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ９`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ１`;
+--error ER_DATA_TOO_LONG
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ２`;
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ３`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ４`;
+--error ER_DATA_TOO_LONG
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ５`;
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ６`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ７`;
+--error ER_DATA_TOO_LONG
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ８`;
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ９`;
 
 #InnoDB
 SELECT * FROM `Ｔ１` WHERE `Ｃ１` LIKE ' %';

=== modified file 'tests/suite/jp/t/jp_select_utf8.test'
--- tests/suite/jp/t/jp_select_utf8.test	2010-08-26 21:56:15 +0000
+++ tests/suite/jp/t/jp_select_utf8.test	2010-09-28 16:06:16 +0000
@@ -29,18 +29,18 @@
 # jisx0208 data
 # jisx0212 supplemental character data
 
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ１`;
---error ER_DATA_TOO_LONG
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ２`;
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ３`;
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ４`;
---error ER_DATA_TOO_LONG
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ５`;
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ６`;
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ７`;
---error ER_DATA_TOO_LONG
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ８`;
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ９`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ１`;
+--error ER_DATA_TOO_LONG
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ２`;
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ３`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ４`;
+--error ER_DATA_TOO_LONG
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ５`;
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ６`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ７`;
+--error ER_DATA_TOO_LONG
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ８`;
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ９`;
 
 #InnoDB
 SELECT * FROM `Ｔ１`;

=== modified file 'tests/suite/jp/t/jp_where_utf8.test'
--- tests/suite/jp/t/jp_where_utf8.test	2010-08-26 21:56:15 +0000
+++ tests/suite/jp/t/jp_where_utf8.test	2010-09-28 16:06:16 +0000
@@ -29,18 +29,18 @@
 # jisx0208 data
 # jisx0212 supplemental character data
 
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ１`;
---error ER_DATA_TOO_LONG
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ２`;
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ３`;
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ４`;
---error ER_DATA_TOO_LONG
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ５`;
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ６`;
-LOAD DATA INFILE '../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ７`;
---error ER_DATA_TOO_LONG
-LOAD DATA INFILE '../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ８`;
-LOAD DATA INFILE '../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ９`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ１`;
+--error ER_DATA_TOO_LONG
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ２`;
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ３`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ４`;
+--error ER_DATA_TOO_LONG
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ５`;
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ６`;
+LOAD DATA INFILE '../../std_data_ln/jisx0201_utf8.dat' INTO TABLE `Ｔ７`;
+--error ER_DATA_TOO_LONG
+LOAD DATA INFILE '../../std_data_ln/jisx0208_utf8.dat' INTO TABLE `Ｔ８`;
+LOAD DATA INFILE '../../std_data_ln/jisx0212_utf8.dat' INTO TABLE `Ｔ９`;
 
 #InnoDB
 SELECT * FROM `Ｔ１` WHERE `Ｃ１` = 'ｰｱｲｳｴｵｶｷｸｹｺｻｼｽｾｿ';

=== modified file 'tests/test-run.pl'
--- tests/test-run.pl	2010-09-22 07:05:47 +0000
+++ tests/test-run.pl	2010-09-28 21:14:58 +0000
@@ -2568,7 +2568,7 @@
                 $prefix, $path_vardir_trace, $mysqld->{'type'}, $sidx);
   }
 
-  mtr_add_arg($args, "%s--sort-buffer=256K", $prefix);
+  mtr_add_arg($args, "%s--sort-buffer-size=256K", $prefix);
   mtr_add_arg($args, "%s--max-heap-table-size=1M", $prefix);
 
   if ( $opt_warnings )
@@ -3490,7 +3490,6 @@
   if ( $opt_callgrind)
   {
     mtr_add_arg($args, "--tool=callgrind");
-    mtr_add_arg($args, "--base=$opt_vardir/log");
   }
   elsif ($opt_massif)
   {

=== modified file 'unittests/client_server.c'
--- unittests/client_server.c	2010-08-12 22:09:24 +0000
+++ unittests/client_server.c	2010-09-28 07:50:05 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

=== modified file 'win32/conn_uds.c'
--- win32/conn_uds.c	2010-08-20 05:59:08 +0000
+++ win32/conn_uds.c	2010-09-28 07:50:05 +0000
@@ -5,7 +5,7 @@
  * All rights reserved.
  *
  * Use and distribution licensed under the BSD license.  See
- * the COPYING file in this directory for full text.
+ * the COPYING.BSD file in the root source directory for full text.
  */
 
 /**

